// 2003.09.08, 2003.12.28, 2004.10.15, 2004.12.05, 2004.12.10, 2005.01.20, 2005.02.23, 2005.07.15, 2005.08.17, 2005.08.23, 2005.12.15, 2009.06.05, 2011,02.22
//****************************************
//**  Copyright  (C)  W.ch  1999-2011   **
//**  Web:  http://www.winchiphead.com  **
//****************************************
//**  WDM for USB interface chip CH375  **
//**  C, VC5.0, Windows 98 DDK          **
//****************************************
//
// USB߽ӿоƬCH375WDM   V2.6
// Ͼߺ޹˾       http://wch.cn
// CH375-WDM  V2.7, Support: Ctrl/Bulk/Int
// л: Windows 98/ME, Windows 2000/XP/VISTA/7/SERVER2003/SERVER2008
// support USB chip: CH372/CH375
//


#define		mTHIS_VERSION			0x26		// ǰ汾
#define		mTHIS_VER_STR			"2.6"		// ǰ汾ַ

#include	<wdm.h>
#include	<usbdi.h>
#include	<usbdlib.h>


#include	"CH375WDM.H"

typedef	struct	_LINK_URB_BUF {
	struct	_LINK_URB_BUF	*mNext;
	URB					mUrb;
	KEVENT				mEvent;
	IO_STATUS_BLOCK		mIoStatusBlock;
	NTSTATUS			mStatus;
	ULONG				mLength;
	UCHAR				mBuffer[ mCH375_PACKET_LENGTH * 2 ];
} mLINK_URB_BUF, *mPLINK_URB_BUF;

#define		mTHREAD_MAX_LINK		10

typedef	struct	_DEVICE_EXTENSION {				// 豸չṹ
	UNICODE_STRING		mExtDeviceName;			// 豸
	PDEVICE_OBJECT		mExtPhysicalTarget;		// 豸ָ
	PDEVICE_OBJECT		mExtNextLowerDevice;	// ¼豸ָ
	USBD_PIPE_HANDLE	mExtInterUpPipe;		// USBжϴܵľ
	USBD_PIPE_HANDLE	mExtAuxDownPipe;		// USB´ܵľ
	USBD_PIPE_HANDLE	mExtDataDownPipe;		// USBݿ´ܵľ
	USBD_PIPE_HANDLE	mExtDataUpPipe;			// USBݿϴܵľ
	ULONG				mExtIoCount;			// ڽеĲ,ֹ;ֹͣƳ豸
	ULONG				mExtDeviceOpen;			// ָʾ豸򿪵Ĵ
	BOOLEAN				mExtDeviceStart;		// ָʾ豸״̬
	BOOLEAN				mExtDeviceRemove;		// ָʾ豸Ƴ״̬
	BOOLEAN				mExtDeviceExclusive;	// ָʾ豸Ƿռʹ
	ULONG				mExtInterTimeout;		// USBжϴܵͨѶʱ
	ULONG				mExtAuxTimeout;			// USB´ܵͨѶʱ
	ULONG				mExtDownTimeout;		// USBݿ´ܵͨѶʱ
	ULONG				mExtUpTimeout;			// USBݿϴܵͨѶʱ
	LARGE_INTEGER		mExtInterWaitTime;
	LARGE_INTEGER		mExtAuxWaitTime;
	LARGE_INTEGER		mExtDownWaitTime;
	LARGE_INTEGER		mExtUpWaitTime;
	KEVENT				mExtThreadToutEvent;
	ULONG				mExtUsbInterCount;
	ULONG				mExtUsbAuxCount;
	ULONG				mExtUsbUpCount;
	ULONG				mExtUsbDownCount;
	LARGE_INTEGER		mExtInterStartTime;
	LARGE_INTEGER		mExtAuxStartTime;
	LARGE_INTEGER		mExtDownStartTime;
	LARGE_INTEGER		mExtUpStartTime;
	PURB				mExtUrbBuffer;			// ָURB
	URB					mExtPublicUrb;			// URB
	KSPIN_LOCK			mControlLock;
	KEVENT				ThreadStartEvent;
	ULONG				ThreadUsbCount;
	PUCHAR				ThreadBuffer;
	mPLINK_URB_BUF		ThreadQueueFree;
	mPLINK_URB_BUF		ThreadQueueWait;
	ULONG				ThreadBufSize;
	PUCHAR				ThreadInStart;
	PUCHAR				ThreadOutStart;
	ULONG				ThreadInSize;
	KSPIN_LOCK			mControlLockDn;
	KEVENT				DnThreadStartEvent;
	ULONG				DnThreadUsbCount;
	PUCHAR				DnThreadBuffer;
	mPLINK_URB_BUF		DnThreadQueueFree;
	mPLINK_URB_BUF		DnThreadQueueWait;
	ULONG				DnThreadBufSize;
	PUCHAR				DnThreadInStart;
	PUCHAR				DnThreadOutStart;
	ULONG				DnThreadInSize;
	ULONG				mPowerState;
	PIRP				mDevPowerIrp;
	ULONG				mOnDevExist;			// ָʾڵü豸ڵӳ
	BOOLEAN				mDeviceGone;		// ָʾ豸Ƿ
	ULONG				mThreadCount;
	KEVENT				ThreadPowerEvent;
} mDEVICE_EXTENSION, *mPDEVICE_EXTENSION;

#define		IO_CH375_INCREMENT		5			// CH375ȼ


// ˵
UCHAR			mDescription[128] = " CH375 WDM V" mTHIS_VER_STR " "
									" Author : W.ch  "
									"HX.S065  2003.12\xd\xa"
									" www.wch99.com  \xd\xa"
									" Copyright (C) W.ch 1999-2005 \xd\xa\x0";

PDRIVER_OBJECT	mDriverObject = NULL;			// ,Чָʾϵͳֹ߳


// ӳ˵


NTSTATUS		DriverEntry( PDRIVER_OBJECT iDriverObject, PUNICODE_STRING iRegistryPath );
VOID			mDriverUnload( PDRIVER_OBJECT iDriverObject );
NTSTATUS		mAddDevice( PDRIVER_OBJECT iDriverObject, PDEVICE_OBJECT iPhysicalDeviceObject );
VOID			mRemoveDevice( PDEVICE_OBJECT iDeviceObject );
NTSTATUS		mDispatchCreate( PDEVICE_OBJECT iDeviceObject, PIRP iIrp );
NTSTATUS		mDispatchClose( PDEVICE_OBJECT iDeviceObject, PIRP iIrp );
NTSTATUS		mPipeInterCompletion( PDEVICE_OBJECT iDeviceObject, PIRP iIrp, PVOID iContext );
NTSTATUS		mPipeAuxCompletion( PDEVICE_OBJECT iDeviceObject, PIRP iIrp, PVOID iContext );
NTSTATUS		mPipeUpCompletion( PDEVICE_OBJECT iDeviceObject, PIRP iIrp, PVOID iContext );
NTSTATUS		mPipeDownCompletion( PDEVICE_OBJECT iDeviceObject, PIRP iIrp, PVOID iContext );
NTSTATUS		mDispatchDeviceControl( PDEVICE_OBJECT iDeviceObject, PIRP iIrp );
NTSTATUS		mRequestPipe( PDEVICE_OBJECT iDeviceObject, USHORT iFunction, ULONG iPipe );
VOID			mCancelCurrentInter( PDEVICE_OBJECT iDeviceObject, PIRP iIrp );
VOID			mCancelCurrentAux( PDEVICE_OBJECT iDeviceObject, PIRP iIrp );
VOID			mCancelCurrentUp( PDEVICE_OBJECT iDeviceObject, PIRP iIrp );
VOID			mCancelCurrentDown( PDEVICE_OBJECT iDeviceObject, PIRP iIrp );
NTSTATUS		mDispatchCleanup( PDEVICE_OBJECT iDeviceObject, PIRP iIrp );
NTSTATUS		mDispatchPower( PDEVICE_OBJECT iDeviceObject, PIRP iIrp );
NTSTATUS		mSysPwrCompletRoutine( PDEVICE_OBJECT iDeviceObject, PIRP iIrp, PPOWER_STATE iPowerState );
VOID			mSysPwrReqCompletion( PDEVICE_OBJECT iDeviceObject, UCHAR iMinorFunction, POWER_STATE iPowerState, PIRP iIrp, PIO_STATUS_BLOCK iIoStatus );
NTSTATUS		mDevPwrCompletRoutine( PDEVICE_OBJECT iDeviceObject, PIRP iIrp, PVOID iContext );
VOID			mThreadDevPower( PVOID iContext );
NTSTATUS		mDispatchSystemControl( PDEVICE_OBJECT iDeviceObject, PIRP iIrp );
NTSTATUS		mDispatchPnp( PDEVICE_OBJECT iDeviceObject, PIRP iIrp );
NTSTATUS		mWaitCompletion( PDEVICE_OBJECT iDeviceObject, PIRP iIrp );
NTSTATUS		mCompletionRoutine( PDEVICE_OBJECT iDeviceObject, PIRP iIrp, PVOID iContext );
NTSTATUS		mActiveConfig( PDEVICE_OBJECT iDeviceObject, PIRP iIrp );
NTSTATUS		mDeactiveConfig( PDEVICE_OBJECT iDeviceObject, PIRP iIrp );
NTSTATUS		mUsbSubmitUrb( PDEVICE_OBJECT iDeviceObject, PURB iUrb );
BOOLEAN			mIsDeviceExist( PDEVICE_OBJECT iDeviceObject, NTSTATUS iStatus );
VOID			mAbortAsyncRead( PDEVICE_OBJECT iDeviceObject );
VOID			mThreadRead( PVOID iContext );
NTSTATUS		mExitThreadRead( PDEVICE_OBJECT iDeviceObject );
NTSTATUS		mGetBufferData( PDEVICE_OBJECT iDeviceObject, PUCHAR oBuffer, PULONG ioLength );
VOID			mClearUpBufferData( PDEVICE_OBJECT iDeviceObject );
VOID			mAbortAsyncWrite( PDEVICE_OBJECT iDeviceObject );
VOID			mThreadWrite( PVOID iContext );
NTSTATUS		mExitThreadWrite( PDEVICE_OBJECT iDeviceObject );
NTSTATUS		mPutBufferData( PDEVICE_OBJECT iDeviceObject, PUCHAR iBuffer, ULONG iLength );
VOID			mClearDnBufferData( PDEVICE_OBJECT iDeviceObject );
NTSTATUS		mResetUsbDevice( PDEVICE_OBJECT iDeviceObject );
VOID			mThreadTimeout( PVOID iContext );
VOID			mDelay20mS( void );


// ʼɺɶĴ
#ifdef		ALLOC_PRAGMA
#pragma		alloc_text( INIT, DriverEntry )
#endif


NTSTATUS	DriverEntry(  // ʼ
	PDRIVER_OBJECT	iDriverObject,  // 
	PUNICODE_STRING	iRegistryPath )
{
	mDriverObject = iDriverObject;  // 
//	while ( mDriverObject );  // 
	iDriverObject -> MajorFunction[ IRP_MJ_CREATE ] = mDispatchCreate;  // ߴ豸
	iDriverObject -> MajorFunction[ IRP_MJ_CLOSE ] = mDispatchClose;  // ر豸
	iDriverObject -> MajorFunction[ IRP_MJ_DEVICE_CONTROL ] = mDispatchDeviceControl;  // 豸
	iDriverObject -> MajorFunction[ IRP_MJ_CLEANUP ] = mDispatchCleanup;  // ȡ
	iDriverObject -> MajorFunction[ IRP_MJ_POWER ] = mDispatchPower;  // Դ
	iDriverObject -> MajorFunction[ IRP_MJ_SYSTEM_CONTROL ] = mDispatchSystemControl;  // ϵͳWMIӿ
	iDriverObject -> MajorFunction[ IRP_MJ_PNP ] = mDispatchPnp;  // 豸PnP
	iDriverObject -> DriverUnload = mDriverUnload;  // ж
	iDriverObject -> DriverExtension -> AddDevice = mAddDevice;  // ⵽Ӳ豸
	return( STATUS_SUCCESS );
}

VOID		mDriverUnload(  // ж
	PDRIVER_OBJECT	iDriverObject )
{
//	mDelay20mS( );
	mDriverObject = NULL;  // ,ָʾϵͳֹ߳
}

NTSTATUS	mAddDevice(  // 豸PnP
	PDRIVER_OBJECT	iDriverObject,  // 
	PDEVICE_OBJECT	iPhysicalDeviceObject )
{
	PDEVICE_OBJECT		mDeviceObject = NULL;
	mPDEVICE_EXTENSION	mDeviceExtension;
	HANDLE				mThreadHandle;
	NTSTATUS			mStatus = STATUS_INSUFFICIENT_RESOURCES;
	__try {  // ȷ˳ǰĴ
		mStatus = IoCreateDevice( iDriverObject, sizeof( mDEVICE_EXTENSION ), NULL,  // 豸
								  FILE_DEVICE_UNKNOWN, 0, FALSE, &mDeviceObject );  // ص豸
		if ( ! NT_SUCCESS( mStatus ) ) __leave;  // 豸ʧ
		mDeviceExtension = mDeviceObject -> DeviceExtension;  // 豸չָ
		RtlZeroMemory( mDeviceExtension, sizeof( mDEVICE_EXTENSION ) );  // ڴ
		mDeviceExtension -> mExtPhysicalTarget = iPhysicalDeviceObject;  // 豸Ĺ豸
		mDeviceExtension -> mExtIoCount = 0;  // 
		mDeviceExtension -> mExtUsbInterCount = 0;  // 
		mDeviceExtension -> mExtUsbAuxCount = 0;  // 
		mDeviceExtension -> mExtUsbUpCount = 0;  // 
		mDeviceExtension -> mExtUsbDownCount = 0;  // 
		mDeviceExtension -> mExtDeviceOpen = 0;  // 豸򿪱־
		mDeviceExtension -> mExtDeviceStart = FALSE;  // 豸־
		mDeviceExtension -> mExtDeviceRemove = FALSE;  // 豸Ƴ־
		mDeviceExtension -> mExtDeviceExclusive = FALSE;  // 豸ʹ
		mDeviceExtension -> mPowerState = PowerDeviceD0;
		mDeviceExtension -> mDeviceGone = FALSE;
		mDeviceExtension -> mOnDevExist = 0;
		mDeviceExtension -> mThreadCount = 0;
		KeInitializeEvent( & mDeviceExtension -> ThreadPowerEvent, SynchronizationEvent, FALSE );
		KeInitializeEvent( & mDeviceExtension -> mExtThreadToutEvent, SynchronizationEvent, FALSE );
		KeInitializeEvent( & mDeviceExtension -> ThreadStartEvent, SynchronizationEvent, FALSE );
		KeInitializeEvent( & mDeviceExtension -> DnThreadStartEvent, SynchronizationEvent, FALSE );
		KeInitializeSpinLock( & mDeviceExtension -> mControlLock );
		KeInitializeSpinLock( & mDeviceExtension -> mControlLockDn );
		mDeviceExtension -> mExtInterTimeout = 0xFFFFFFFF;  // USBжϴܵͨѶʱ
		mDeviceExtension -> mExtAuxTimeout = 2000;  // USB´ܵͨѶʱ
		mDeviceExtension -> mExtAuxWaitTime.QuadPart = (LONGLONG)( mDeviceExtension -> mExtAuxTimeout ) * -10000;  // 㳬ʱ
		mDeviceExtension -> mExtDownTimeout = 0xFFFFFFFF;  // USBݿ´ܵͨѶʱ
		mDeviceExtension -> mExtUpTimeout = 0xFFFFFFFF;  // USBݿϴܵͨѶʱ
		mDeviceExtension -> mExtUrbBuffer = & mDeviceExtension -> mExtPublicUrb;  // URB
		mDeviceExtension -> mExtNextLowerDevice = IoAttachDeviceToDeviceStack( mDeviceObject,  // ҽ豸ջ,¼豸
																			   iPhysicalDeviceObject );  // ָ
		if ( mDeviceExtension -> mExtNextLowerDevice == NULL ) {  // ҽ豸ջʧ
			mStatus = STATUS_UNSUCCESSFUL;  // شϢ
			__leave;
		}
		mStatus = IoRegisterDeviceInterface( iPhysicalDeviceObject, &CH375Guid,  // ע豸ӿ
											 NULL, & mDeviceExtension -> mExtDeviceName );  // 
		mDeviceObject -> Flags |= DO_BUFFERED_IO | DO_POWER_PAGABLE;  // IO,ָʾڷҳڴ
		mDeviceObject -> Flags &= ~DO_DEVICE_INITIALIZING;  // ʼ
		PsCreateSystemThread( &mThreadHandle, 0, NULL, NULL, NULL, mThreadTimeout, mDeviceObject );  // ½ϵͳ߳
		ZwClose( mThreadHandle );  // رվ
		PsCreateSystemThread( &mThreadHandle, 0, NULL, NULL, NULL, mThreadDevPower, mDeviceObject );  // ½ϵͳ߳
		ZwClose( mThreadHandle );  // رվ
	}
	__finally {  // ˳ǰĴ
		if ( ! NT_SUCCESS( mStatus ) ) {  // ʼʧ
			mRemoveDevice( mDeviceObject );  // Ƴ豸
		}
	}
	return( STATUS_SUCCESS );
}

VOID		mRemoveDevice(  // Ƴ豸
	PDEVICE_OBJECT	iDeviceObject )
{
	ULONG				mDeviceInstance;
	mPDEVICE_EXTENSION	mDeviceExtension;
	if ( iDeviceObject == NULL ) return;  // 豸Ч
	mDeviceExtension = iDeviceObject -> DeviceExtension;  // 豸չ
	if ( mDeviceExtension -> mExtDeviceName.Buffer != NULL ) {  // Ѿע豸ӿ
		IoSetDeviceInterfaceState( & mDeviceExtension -> mExtDeviceName, FALSE );  // 豸ӿ
		RtlFreeUnicodeString( & mDeviceExtension -> mExtDeviceName );  // ͷ豸ƻ
		mDeviceExtension -> mExtDeviceName.Buffer = NULL;
	}
	while ( mDeviceExtension -> mThreadCount ) {
		KeSetEvent( & mDeviceExtension -> mExtThreadToutEvent, IO_CH375_INCREMENT, FALSE );  // ߳¼
		KeSetEvent( & mDeviceExtension -> ThreadPowerEvent, IO_CH375_INCREMENT, FALSE );  // ߳¼
		mDelay20mS( );
	}
	if ( mDeviceExtension -> mExtNextLowerDevice != NULL ) {  // Ѿҽӵ豸ջ
		IoDetachDevice( mDeviceExtension -> mExtNextLowerDevice );  // 豸ջ
		mDeviceExtension -> mExtNextLowerDevice = NULL;
	}
	IoDeleteDevice( iDeviceObject );  // ɾ豸
}

NTSTATUS	mDispatchCreate(  // ½ߴ
	PDEVICE_OBJECT	iDeviceObject,
	PIRP			iIrp )
{
	ULONG	mCount;
	mPDEVICE_EXTENSION	mDeviceExtension = iDeviceObject -> DeviceExtension;  // 豸չ
	iIrp -> IoStatus.Information = 0;
	mCount = InterlockedIncrement( & mDeviceExtension -> mExtDeviceOpen );  // 򿪼
	if ( mDeviceExtension -> mExtDeviceExclusive && mCount > 1 ) {  // 豸ռʹ
		InterlockedDecrement( & mDeviceExtension -> mExtDeviceOpen );  // 򿪼
		iIrp -> IoStatus.Status = STATUS_ACCESS_DENIED;  // ز״̬
		IoCompleteRequest( iIrp, IO_NO_INCREMENT );  // 
		return( STATUS_ACCESS_DENIED );  // ״̬
	}
	iIrp -> IoStatus.Status = STATUS_SUCCESS;  // ز״̬
	KeSetEvent( & mDeviceExtension -> mExtThreadToutEvent, EVENT_INCREMENT, FALSE );  // ߳¼
	KeSetEvent( & mDeviceExtension -> ThreadStartEvent, EVENT_INCREMENT, FALSE );  // ߳¼
	KeSetEvent( & mDeviceExtension -> DnThreadStartEvent, EVENT_INCREMENT, FALSE );  // ߳¼
	IoCompleteRequest( iIrp, IO_NO_INCREMENT );  // 
	return( STATUS_SUCCESS );  // ״̬
}

NTSTATUS	mDispatchClose(  // ر
	PDEVICE_OBJECT	iDeviceObject,
	PIRP			iIrp )
{
	mPDEVICE_EXTENSION	mDeviceExtension = iDeviceObject -> DeviceExtension;  // 豸չ
	if ( mDeviceExtension -> mExtDeviceOpen ) InterlockedDecrement( & mDeviceExtension -> mExtDeviceOpen );  // ر򿪼
	iIrp -> IoStatus.Status = STATUS_SUCCESS;  // ز״̬
	iIrp -> IoStatus.Information = 0;
	IoCompleteRequest( iIrp, IO_NO_INCREMENT );  // 
	return( STATUS_SUCCESS );  // ״̬
}

NTSTATUS	mPipeInterCompletion(
	PDEVICE_OBJECT	iDeviceObject,
	PIRP			iIrp,
	PVOID			iContext )
{
	NTSTATUS			mStatus;
	PURB				mUrb;
	mPWIN32_COMMAND		mWin32Command;
	mPDEVICE_EXTENSION	mDeviceExtension = iDeviceObject -> DeviceExtension;  // 豸չ
	mUrb = iContext;
	if ( iIrp -> IoStatus.Status == STATUS_CANCELLED ) iIrp -> IoStatus.Status = STATUS_TIMEOUT;  // ȡ
	mStatus = iIrp -> IoStatus.Status;
	mWin32Command = iIrp -> AssociatedIrp.SystemBuffer;  // 
	mWin32Command -> mStatus = mStatus;  // ز״̬
	mWin32Command -> mLength = mUrb -> UrbBulkOrInterruptTransfer.TransferBufferLength;  // ʵʴ䳤
	if ( mUrb == & mDeviceExtension -> mExtPublicUrb ) mDeviceExtension -> mExtUrbBuffer = mUrb;
	else ExFreePool( mUrb );  // ͷڴ
	if ( NT_SUCCESS( mStatus ) ) iIrp -> IoStatus.Information = mWin32Command -> mLength + mWIN32_COMMAND_HEAD;  // ͷȵ÷ݵܳ
	if ( InterlockedDecrement( & mDeviceExtension -> mExtUsbInterCount ) == 0 ) mDeviceExtension -> mExtInterStartTime.QuadPart = 0;  // 峬ʱ
	InterlockedDecrement( & mDeviceExtension -> mExtIoCount );  // 
	return( mStatus );
}

NTSTATUS	mPipeAuxCompletion(
	PDEVICE_OBJECT	iDeviceObject,
	PIRP			iIrp,
	PVOID			iContext )
{
	NTSTATUS			mStatus;
	PURB				mUrb;
	mPWIN32_COMMAND		mWin32Command;
	mPDEVICE_EXTENSION	mDeviceExtension = iDeviceObject -> DeviceExtension;  // 豸չ
	mUrb = iContext;
	if ( iIrp -> IoStatus.Status == STATUS_CANCELLED ) iIrp -> IoStatus.Status = STATUS_TIMEOUT;  // ȡ
	mStatus = iIrp -> IoStatus.Status;
	mWin32Command = iIrp -> AssociatedIrp.SystemBuffer;  // 
	mWin32Command -> mStatus = mStatus;  // ز״̬
	mWin32Command -> mLength = mUrb -> UrbBulkOrInterruptTransfer.TransferBufferLength;  // ʵʴ䳤
	if ( mUrb == & mDeviceExtension -> mExtPublicUrb ) mDeviceExtension -> mExtUrbBuffer = mUrb;
	else ExFreePool( mUrb );  // ͷڴ
	if ( NT_SUCCESS( mStatus ) ) iIrp -> IoStatus.Information = mWin32Command -> mLength + mWIN32_COMMAND_HEAD;  // ͷȵ÷ݵܳ
	if ( InterlockedDecrement( & mDeviceExtension -> mExtUsbAuxCount ) == 0 ) mDeviceExtension -> mExtAuxStartTime.QuadPart = 0;  // 峬ʱ
	InterlockedDecrement( & mDeviceExtension -> mExtIoCount );  // 
	return( mStatus );
}

NTSTATUS	mPipeUpCompletion(
	PDEVICE_OBJECT	iDeviceObject,
	PIRP			iIrp,
	PVOID			iContext )
{
	NTSTATUS			mStatus;
	PURB				mUrb;
	mPWIN32_COMMAND		mWin32Command;
	mPDEVICE_EXTENSION	mDeviceExtension = iDeviceObject -> DeviceExtension;  // 豸չ
	mUrb = iContext;
	if ( iIrp -> IoStatus.Status == STATUS_CANCELLED ) iIrp -> IoStatus.Status = STATUS_TIMEOUT;  // ȡ
	mStatus = iIrp -> IoStatus.Status;
	mWin32Command = iIrp -> AssociatedIrp.SystemBuffer;  // 
	mWin32Command -> mStatus = mStatus;  // ز״̬
	mWin32Command -> mLength = mUrb -> UrbBulkOrInterruptTransfer.TransferBufferLength;  // ʵʴ䳤
	if ( mUrb == & mDeviceExtension -> mExtPublicUrb ) mDeviceExtension -> mExtUrbBuffer = mUrb;
	else ExFreePool( mUrb );  // ͷڴ
	if ( NT_SUCCESS( mStatus ) ) iIrp -> IoStatus.Information = mWin32Command -> mLength + mWIN32_COMMAND_HEAD;  // ͷȵ÷ݵܳ
	if ( InterlockedDecrement( & mDeviceExtension -> mExtUsbUpCount ) == 0 ) mDeviceExtension -> mExtUpStartTime.QuadPart = 0;  // 峬ʱ
	InterlockedDecrement( & mDeviceExtension -> mExtIoCount );  // 
	return( mStatus );
}

NTSTATUS	mPipeDownCompletion(
	PDEVICE_OBJECT	iDeviceObject,
	PIRP			iIrp,
	PVOID			iContext )
{
	NTSTATUS			mStatus;
	PURB				mUrb;
	mPWIN32_COMMAND		mWin32Command;
	mPDEVICE_EXTENSION	mDeviceExtension = iDeviceObject -> DeviceExtension;  // 豸չ
	mUrb = iContext;
	if ( iIrp -> IoStatus.Status == STATUS_CANCELLED ) iIrp -> IoStatus.Status = STATUS_TIMEOUT;  // ȡ
	mStatus = iIrp -> IoStatus.Status;
	mWin32Command = iIrp -> AssociatedIrp.SystemBuffer;  // 
	mWin32Command -> mStatus = mStatus;  // ز״̬
	mWin32Command -> mLength = mUrb -> UrbBulkOrInterruptTransfer.TransferBufferLength;  // ʵʴ䳤
	if ( mUrb == & mDeviceExtension -> mExtPublicUrb ) mDeviceExtension -> mExtUrbBuffer = mUrb;
	else ExFreePool( mUrb );  // ͷڴ
	if ( NT_SUCCESS( mStatus ) ) iIrp -> IoStatus.Information = mWin32Command -> mLength + mWIN32_COMMAND_HEAD;  // ͷȵ÷ݵܳ
	if ( InterlockedDecrement( & mDeviceExtension -> mExtUsbDownCount ) == 0 ) mDeviceExtension -> mExtDownStartTime.QuadPart = 0;  // 峬ʱ
	InterlockedDecrement( & mDeviceExtension -> mExtIoCount );  // 
	return( mStatus );
}

NTSTATUS	mDispatchDeviceControl(  // 豸
	PDEVICE_OBJECT	iDeviceObject,
	PIRP			iIrp )
{
	UCHAR				mRequestType, mRequestCode;
	USHORT				mRequestValue, mRequestIndex;
	ULONG				mControlCode;
	ULONG				mFunction, mLength, mReturn;
	ULONG				mTransferFlags, mParameter;
	LARGE_INTEGER		mWaitTime;
	PVOID				mBuffer;
	mPWIN32_COMMAND		mWin32Command;
	NTSTATUS			mStatus;
	PURB				mUrb;
	HANDLE				mThreadHandle;
	PIO_STACK_LOCATION	mCurrentIrpStack;
	PIO_STACK_LOCATION	mNextIrpStack;
	mPDEVICE_EXTENSION	mDeviceExtension = iDeviceObject -> DeviceExtension;  // 豸չ
	if ( mDeviceExtension -> mPowerState == PowerDeviceD3 ) {
		iIrp -> IoStatus.Status = STATUS_INVALID_DEVICE_STATE;
		IoSetCancelRoutine( iIrp, NULL );
		mDelay20mS( );
		IoCompleteRequest( iIrp, IO_NO_INCREMENT );
		return( STATUS_INVALID_DEVICE_STATE );
	}
	InterlockedIncrement( & mDeviceExtension -> mExtIoCount );  // ,ֹ;ֹͣƳ豸
	mCurrentIrpStack = IoGetCurrentIrpStackLocation( iIrp );  // ǰջԪָ
	mControlCode = mCurrentIrpStack -> Parameters.DeviceIoControl.IoControlCode;  // 
	if ( mControlCode == IOCTL_CH375_COMMAND ) {  // רýӿ
		mStatus = STATUS_SUCCESS;  // ״̬ԤΪɹ
		mReturn = 0;  // ݳԤΪ0
		mUrb = InterlockedExchangePointer( & mDeviceExtension -> mExtUrbBuffer, NULL );  // ʹùURB
		if ( mUrb == NULL ) mUrb = ExAllocatePool( NonPagedPool, sizeof( URB ) );  // ڴΪURB
		if (  mUrb != NULL && mCurrentIrpStack -> Parameters.DeviceIoControl.InputBufferLength >= mWIN32_COMMAND_HEAD ) {  // 뻺Ч
			mWin32Command = iIrp -> AssociatedIrp.SystemBuffer;  // 
			mFunction = mWin32Command -> mFunction;  // ܴ
			mLength = mWin32Command -> mLength;  // ȡ
			mBuffer = & mWin32Command -> mBuffer[0];  // ݻ
			switch( mFunction ) {  // ܴ
				case mFuncGetVersion:  // ȡ汾
					while ( mLength >= sizeof( ULONG ) && *(PULONG)mBuffer == 'hc.W' );  // ȴԹW.ch
					*(PUCHAR)mBuffer = mTHIS_VERSION;  // 汾
					mReturn = sizeof( UCHAR );  // ݳ
					break;
				case mFuncGetConfig:  // ȡUSB豸
					UsbBuildGetDescriptorRequest( mUrb, sizeof( struct _URB_CONTROL_DESCRIPTOR_REQUEST ),  // ȡURB
												  USB_CONFIGURATION_DESCRIPTOR_TYPE, 0, 0, mBuffer, NULL, mLength, NULL );
					mStatus = mUsbSubmitUrb( iDeviceObject, mUrb );  // ύURB
					mReturn = mUrb -> UrbControlDescriptorRequest.TransferBufferLength;  // ʵʴ䳤
					break;
				case mPipeDeviceCtrl:  // CH375ۺϿƹܵ
					mRequestType = mWin32Command -> mSetupPkt.mUspReqType;  // 
					mRequestCode = mWin32Command -> mSetupPkt.mUspRequest;  // 
					mRequestValue = mWin32Command -> mSetupPkt.mUspValue;  // ֵ
					mRequestIndex = mWin32Command -> mSetupPkt.mUspIndex;  // 
					mLength = mWin32Command -> mSetupPkt.mLength;  // ݳ
					mTransferFlags = ( ( mRequestType & 0x80 ) != 0 ? USBD_TRANSFER_DIRECTION_IN : 0 ) | USBD_SHORT_TRANSFER_OK;  // ־
					switch( mRequestType >> 5 & 0x03 ) {  // 
						case 0:  // ׼
							switch( mRequestCode ) {  // 
								case USB_REQUEST_CLEAR_FEATURE:  // 
									UsbBuildFeatureRequest( mUrb, URB_FUNCTION_CLEAR_FEATURE_TO_DEVICE,  // URB
															mRequestValue, mRequestIndex, NULL );
									mStatus = mUsbSubmitUrb( iDeviceObject, mUrb );  // ύURB
									break;
								case USB_REQUEST_SET_FEATURE:  // 
									UsbBuildFeatureRequest( mUrb, URB_FUNCTION_SET_FEATURE_TO_DEVICE,  // URB
															mRequestValue, mRequestIndex, NULL );
									mStatus = mUsbSubmitUrb( iDeviceObject, mUrb );  // ύURB
									break;
								case USB_REQUEST_GET_STATUS:  // ȡ״̬
									UsbBuildGetStatusRequest( mUrb, URB_FUNCTION_GET_STATUS_FROM_DEVICE,  // ȡ״̬URB
															  mRequestIndex, mBuffer, NULL, NULL );
									mStatus = mUsbSubmitUrb( iDeviceObject, mUrb );  // ύURB
									mReturn = mUrb -> UrbControlGetStatusRequest.TransferBufferLength;  // ʵʴ䳤
									break;
								case USB_REQUEST_GET_DESCRIPTOR:  // ȡ
									mParameter = ( mRequestValue >> 8 ) == 1 ? USB_DEVICE_DESCRIPTOR_TYPE : USB_CONFIGURATION_DESCRIPTOR_TYPE;  // 
									UsbBuildGetDescriptorRequest( mUrb, sizeof( struct _URB_CONTROL_DESCRIPTOR_REQUEST ),  // ȡURB
																  (UCHAR)mParameter, 0, 0, mBuffer, NULL, mLength, NULL );
									mStatus = mUsbSubmitUrb( iDeviceObject, mUrb );  // ύURB
									mReturn = mUrb -> UrbControlDescriptorRequest.TransferBufferLength;  // ʵʴ䳤
									break;
								default:  // ֧
									mStatus = STATUS_INVALID_PARAMETER;  // ش
									break;
							}
							break;
						case 2:  // Ӧ
							switch( mRequestType & 0x03 ) {  // 
								case 0:  // 豸
									mParameter = URB_FUNCTION_VENDOR_DEVICE;
									break;
								case 1:  // ӿ
									mParameter = URB_FUNCTION_VENDOR_INTERFACE;
									break;
								case 2:  // ˵
									mParameter = URB_FUNCTION_VENDOR_ENDPOINT;
									break;
								default:  // 
									mParameter = URB_FUNCTION_VENDOR_OTHER;
									break;
							}
							UsbBuildVendorRequest( mUrb, (USHORT)mParameter,  // USBӦ
												   sizeof( struct _URB_CONTROL_VENDOR_OR_CLASS_REQUEST ),  // URBṹ
												   mTransferFlags, 0, mRequestCode, mRequestValue, mRequestIndex,  // 
												   mBuffer, NULL, mLength, NULL );  // 
							mStatus = mUsbSubmitUrb( iDeviceObject, mUrb );  // ύURB
							mReturn = mUrb -> UrbControlVendorClassRequest.TransferBufferLength;  // ʵʴ䳤
							break;
						default:  // ֵ֧
							mStatus = STATUS_INVALID_PARAMETER;  // ش
							break;
					}
					break;
				case mPipeInterUp:  // CH375жϴܵ
					if ( mDeviceExtension -> mExtInterUpPipe != NULL ) {  // ܵЧ
						mTransferFlags = USBD_TRANSFER_DIRECTION_IN | USBD_SHORT_TRANSFER_OK;  // ־
						UsbBuildInterruptOrBulkTransferRequest( mUrb, sizeof( struct _URB_BULK_OR_INTERRUPT_TRANSFER ),  // USB
																mDeviceExtension -> mExtInterUpPipe,  // ܵľ
																mBuffer, NULL, mLength, mTransferFlags, NULL );  // ־
						mUrb -> UrbBulkOrInterruptTransfer.Hdr.Status = USBD_STATUS_HALTED;
						mNextIrpStack = IoGetNextIrpStackLocation( iIrp );
						mNextIrpStack -> MajorFunction = IRP_MJ_INTERNAL_DEVICE_CONTROL;
						mNextIrpStack -> Parameters.Others.Argument1 = (PVOID) mUrb;  // URBΪݸ¼豸
						mNextIrpStack -> Parameters.DeviceIoControl.IoControlCode = IOCTL_INTERNAL_USB_SUBMIT_URB;
						IoSetCompletionRoutine( iIrp, mPipeInterCompletion, mUrb, TRUE, TRUE, TRUE );
						IoMarkIrpPending( iIrp );
						InterlockedIncrement( & mDeviceExtension -> mExtUsbInterCount );  // 
						if ( mDeviceExtension -> mExtInterTimeout < 0x80000000 ) {  // Ҫ鳬ʱ
							KeQuerySystemTime( & mDeviceExtension -> mExtInterStartTime );
							KeSetEvent( & mDeviceExtension -> mExtThreadToutEvent, EVENT_INCREMENT, FALSE );  // ߳¼
						}
						//IoSetCancelRoutine( iIrp, mCancelCurrentInter );
						mStatus = IoCallDriver( mDeviceExtension -> mExtNextLowerDevice, iIrp );  // ¼豸IO
						if ( ! NT_SUCCESS( mStatus ) ) {
							if ( mStatus != STATUS_CANCELLED && mStatus != STATUS_DEVICE_NOT_CONNECTED ) mRequestPipe( iDeviceObject, URB_FUNCTION_RESET_PIPE, mPipeInterUp );
						}
						return( STATUS_PENDING );  // صȴ
					}
					else mStatus = STATUS_NO_SUCH_DEVICE ;  // ܵЧ,豸Ч
					break;
				case mPipeAuxDown:  // CH375ĸ´ܵ
					if ( mDeviceExtension -> mExtAuxDownPipe != NULL ) {  // ܵЧ
						mTransferFlags = USBD_SHORT_TRANSFER_OK;  // ־
						UsbBuildInterruptOrBulkTransferRequest( mUrb, sizeof( struct _URB_BULK_OR_INTERRUPT_TRANSFER ),  // USB
																mDeviceExtension -> mExtAuxDownPipe,  // ܵľ
																mBuffer, NULL, mLength, mTransferFlags, NULL );  // ־
						mUrb -> UrbBulkOrInterruptTransfer.Hdr.Status = USBD_STATUS_HALTED;
						mNextIrpStack = IoGetNextIrpStackLocation( iIrp );
						mNextIrpStack -> MajorFunction = IRP_MJ_INTERNAL_DEVICE_CONTROL;
						mNextIrpStack -> Parameters.Others.Argument1 = (PVOID) mUrb;  // URBΪݸ¼豸
						mNextIrpStack -> Parameters.DeviceIoControl.IoControlCode = IOCTL_INTERNAL_USB_SUBMIT_URB;
						IoSetCompletionRoutine( iIrp, mPipeAuxCompletion, mUrb, TRUE, TRUE, TRUE );
						IoMarkIrpPending( iIrp );
						InterlockedIncrement( & mDeviceExtension -> mExtUsbAuxCount );  // 
						if ( mDeviceExtension -> mExtAuxTimeout < 0x80000000 ) {  // Ҫ鳬ʱ
							KeQuerySystemTime( & mDeviceExtension -> mExtAuxStartTime );
							KeSetEvent( & mDeviceExtension -> mExtThreadToutEvent, EVENT_INCREMENT, FALSE );  // ߳¼
						}
						//IoSetCancelRoutine( iIrp, mCancelCurrentAux );
						mStatus = IoCallDriver( mDeviceExtension -> mExtNextLowerDevice, iIrp );  // ¼豸IO
						if ( ! NT_SUCCESS( mStatus ) ) {
							if ( mStatus != STATUS_CANCELLED && mStatus != STATUS_DEVICE_NOT_CONNECTED ) mRequestPipe( iDeviceObject, URB_FUNCTION_RESET_PIPE, mPipeAuxDown );
						}
						return( STATUS_PENDING );  // صȴ
					}
					else mStatus = STATUS_NO_SUCH_DEVICE ;  // ܵЧ,豸Ч
					break;
				case mPipeDataUp:  // CH375ݿϴܵ
					if ( mDeviceExtension -> mExtDataUpPipe != NULL ) {  // ܵЧ
						if ( mDeviceExtension -> ThreadBuffer ) {  // ̶߳ȡ
							mReturn = mLength;
							mStatus = mGetBufferData( iDeviceObject, mBuffer, &mReturn );  // ֱӻȡ߳
						}
						else {
							mTransferFlags = USBD_TRANSFER_DIRECTION_IN | USBD_SHORT_TRANSFER_OK;  // ־
							UsbBuildInterruptOrBulkTransferRequest( mUrb, sizeof( struct _URB_BULK_OR_INTERRUPT_TRANSFER ),  // USB
																	mDeviceExtension -> mExtDataUpPipe,  // ܵľ
																	mBuffer, NULL, mLength, mTransferFlags, NULL );  // ־
							mUrb -> UrbBulkOrInterruptTransfer.Hdr.Status = USBD_STATUS_HALTED;
							mNextIrpStack = IoGetNextIrpStackLocation( iIrp );
							mNextIrpStack -> MajorFunction = IRP_MJ_INTERNAL_DEVICE_CONTROL;
							mNextIrpStack -> Parameters.Others.Argument1 = (PVOID) mUrb;  // URBΪݸ¼豸
							mNextIrpStack -> Parameters.DeviceIoControl.IoControlCode = IOCTL_INTERNAL_USB_SUBMIT_URB;
							IoSetCompletionRoutine( iIrp, mPipeUpCompletion, mUrb, TRUE, TRUE, TRUE );
							IoMarkIrpPending( iIrp );
							InterlockedIncrement( & mDeviceExtension -> mExtUsbUpCount );  // 
							if ( mDeviceExtension -> mExtUpTimeout < 0x80000000 ) {  // Ҫ鳬ʱ
								KeQuerySystemTime( & mDeviceExtension -> mExtUpStartTime );
								KeSetEvent( & mDeviceExtension -> mExtThreadToutEvent, EVENT_INCREMENT, FALSE );  // ߳¼
							}
							//IoSetCancelRoutine( iIrp, mCancelCurrentUp );
							mStatus = IoCallDriver( mDeviceExtension -> mExtNextLowerDevice, iIrp );  // ¼豸IO
							if ( ! NT_SUCCESS( mStatus ) ) {
								if ( mStatus != STATUS_CANCELLED && mStatus != STATUS_DEVICE_NOT_CONNECTED ) mRequestPipe( iDeviceObject, URB_FUNCTION_RESET_PIPE, mPipeDataUp );
							}
							return( STATUS_PENDING );  // صȴ
						}
					}
					else mStatus = STATUS_NO_SUCH_DEVICE ;  // ܵЧ,豸Ч
					break;
				case mPipeDataDown:  // CH375ݿ´ܵ
					if ( mDeviceExtension -> mExtDataDownPipe != NULL ) {  // ܵЧ
						if ( mDeviceExtension -> DnThreadBuffer ) {  // ̶߳ȡ
							mReturn = mLength;
							mStatus = mPutBufferData( iDeviceObject, mBuffer, mReturn );  // ֱӽ͸߳
						}
						else {
							mTransferFlags = USBD_SHORT_TRANSFER_OK;  // ־
							UsbBuildInterruptOrBulkTransferRequest( mUrb, sizeof( struct _URB_BULK_OR_INTERRUPT_TRANSFER ),  // USB
																	mDeviceExtension -> mExtDataDownPipe,  // ܵľ
																	mBuffer, NULL, mLength, mTransferFlags, NULL );  // ־
							mUrb -> UrbBulkOrInterruptTransfer.Hdr.Status = USBD_STATUS_HALTED;
							mNextIrpStack = IoGetNextIrpStackLocation( iIrp );
							mNextIrpStack -> MajorFunction = IRP_MJ_INTERNAL_DEVICE_CONTROL;
							mNextIrpStack -> Parameters.Others.Argument1 = (PVOID) mUrb;  // URBΪݸ¼豸
							mNextIrpStack -> Parameters.DeviceIoControl.IoControlCode = IOCTL_INTERNAL_USB_SUBMIT_URB;
							IoSetCompletionRoutine( iIrp, mPipeDownCompletion, mUrb, TRUE, TRUE, TRUE );
							IoMarkIrpPending( iIrp );
							InterlockedIncrement( & mDeviceExtension -> mExtUsbDownCount );  // 
							if ( mDeviceExtension -> mExtDownTimeout < 0x80000000 ) {  // Ҫ鳬ʱ
								KeQuerySystemTime( & mDeviceExtension -> mExtDownStartTime );
								KeSetEvent( & mDeviceExtension -> mExtThreadToutEvent, EVENT_INCREMENT, FALSE );  // ߳¼
							}
							//IoSetCancelRoutine( iIrp, mCancelCurrentDown );
							mStatus = IoCallDriver( mDeviceExtension -> mExtNextLowerDevice, iIrp );  // ¼豸IO
							if ( ! NT_SUCCESS( mStatus ) ) {
								if ( mStatus != STATUS_CANCELLED && mStatus != STATUS_DEVICE_NOT_CONNECTED ) mRequestPipe( iDeviceObject, URB_FUNCTION_RESET_PIPE, mPipeDataDown );
							}
							return( STATUS_PENDING );  // صȴ
						}
					}
					else mStatus = STATUS_NO_SUCH_DEVICE ;  // ܵЧ,豸Ч
					break;
				case mFuncResetDevice:  // λUSB豸
					mStatus = mResetUsbDevice( iDeviceObject );
					break;
				case mFuncResetPipe:  // λUSBܵ
					mStatus = mRequestPipe( iDeviceObject, URB_FUNCTION_RESET_PIPE, *(PULONG)mBuffer );  // ִָܵиλ
					break;
				case mFuncAbortPipe:  // ȡUSBܵ
					mStatus = mRequestPipe( iDeviceObject, URB_FUNCTION_ABORT_PIPE, *(PULONG)mBuffer );  // ִָܵȡ
					break;
				case mFuncSetTimeout:  // USBͨѶʱ
					mDeviceExtension -> mExtDownTimeout = *(PULONG)( (PUCHAR)mBuffer + 0 );  // USBݿ´ܵͨѶʱ,mS
					if ( mDeviceExtension -> mExtDownTimeout == 0 ) mDeviceExtension -> mExtDownTimeout = 1;
					mDeviceExtension -> mExtDownWaitTime.QuadPart = (LONGLONG)( mDeviceExtension -> mExtDownTimeout ) * 10000;  // 㳬ʱ
					mDeviceExtension -> mExtUpTimeout = *(PULONG)( (PUCHAR)mBuffer + 4 );  // USBݿϴܵͨѶʱ,mS
					if ( mDeviceExtension -> mExtUpTimeout == 0 ) mDeviceExtension -> mExtUpTimeout = 1;
					mDeviceExtension -> mExtUpWaitTime.QuadPart = (LONGLONG)( mDeviceExtension -> mExtUpTimeout ) * 10000;  // 㳬ʱ
					if ( mLength >= sizeof( ULONG ) * 4 ) {
						mDeviceExtension -> mExtAuxTimeout = *(PULONG)( (PUCHAR)mBuffer + 8 );  // USB´ܵͨѶʱ,mS
						if ( mDeviceExtension -> mExtAuxTimeout == 0 ) mDeviceExtension -> mExtAuxTimeout = 1;
						mDeviceExtension -> mExtAuxWaitTime.QuadPart = (LONGLONG)( mDeviceExtension -> mExtAuxTimeout ) * 10000;  // 㳬ʱ
						mDeviceExtension -> mExtInterTimeout = *(PULONG)( (PUCHAR)mBuffer + 12 );  // USBжϴܵͨѶʱ,mS
						if ( mDeviceExtension -> mExtInterTimeout == 0 ) mDeviceExtension -> mExtInterTimeout = 1;
						mDeviceExtension -> mExtInterWaitTime.QuadPart = (LONGLONG)( mDeviceExtension -> mExtInterTimeout ) * 10000;  // 㳬ʱ
					}
					break;
				case mFuncSetExclusive:  // öռʹ
					if ( *(PUCHAR)mBuffer ) mDeviceExtension -> mExtDeviceExclusive = TRUE;  // 豸ռʹ
					else mDeviceExtension -> mExtDeviceExclusive = FALSE;  // 豸ʹ
					*(PULONG)mBuffer = mDeviceExtension -> mExtDeviceOpen;  // 豸Ѿ򿪵Ĵ
					mReturn = sizeof( ULONG );  // ݳ
					break;
				case mFuncBufferMode:  // 趨ϴģʽȡеݳ
					KeSetEvent( & mDeviceExtension -> ThreadStartEvent, IO_CH375_INCREMENT, FALSE );  // ߳¼
					mReturn = *(PUCHAR)mBuffer;
					*(PULONG)mBuffer = 0;  // ػѽյϴĸ
					switch ( mReturn ) {
						case 0:  // رջģʽ
							mStatus = mExitThreadRead( iDeviceObject );  // ˳߳
							break;
						case 1:  // ѯ
							if ( mDeviceExtension -> ThreadBuffer ) *(PULONG)mBuffer = mDeviceExtension -> ThreadInSize / ( mCH375_PACKET_LENGTH + 1 );
							else mStatus = STATUS_INSUFFICIENT_RESOURCES;  // δ
							break;
						case 2:  // ûģʽ,ջ
							if ( mDeviceExtension -> mExtDataUpPipe != NULL ) {  // ܵЧ
								if ( mDeviceExtension -> ThreadBuffer == NULL ) {  // ½
									PsCreateSystemThread( &mThreadHandle, 0, NULL, NULL, NULL, mThreadRead, iDeviceObject );  // ½ϵͳ߳
									ZwClose( mThreadHandle );  // رվ
									for ( mReturn = 0; mReturn < 50; mReturn ++ ) {
										if ( mDeviceExtension -> ThreadBuffer ) break;
										mDelay20mS( );
									}
									mStatus = mReturn >= 50 ? STATUS_UNSUCCESSFUL : STATUS_SUCCESS;
									mReturn = 0;
								}
								else mClearUpBufferData( iDeviceObject );  // Ѵ建
							}
							else mStatus = STATUS_NO_SUCH_DEVICE ;  // ܵЧ,豸Ч
							break;
						default:
							mStatus = STATUS_INVALID_PARAMETER;  // ش
							break;
					}
					mReturn = sizeof( ULONG );  // ݳ
					break;
				case mFuncBufferModeDn:  // 趨´ģʽȡеݳ
					KeSetEvent( & mDeviceExtension -> DnThreadStartEvent, IO_CH375_INCREMENT, FALSE );  // ߳¼
					mReturn = *(PUCHAR)mBuffer;
					*(PULONG)mBuffer = 0;  // ػѽյϴĸ
					switch ( mReturn ) {
						case 0:  // رջģʽ
							mStatus = mExitThreadWrite( iDeviceObject );  // ˳߳
							break;
						case 1:  // ѯ
							if ( mDeviceExtension -> DnThreadBuffer ) *(PULONG)mBuffer = mDeviceExtension -> DnThreadInSize / ( mCH375_PACKET_LENGTH + 1 ) + mDeviceExtension -> DnThreadUsbCount;
							else mStatus = STATUS_INSUFFICIENT_RESOURCES;  // δ
							break;
						case 2:  // ûģʽ,ջ
							if ( mDeviceExtension -> mExtDataDownPipe != NULL ) {  // ܵЧ
								if ( mDeviceExtension -> DnThreadBuffer == NULL ) {  // ½
									PsCreateSystemThread( &mThreadHandle, 0, NULL, NULL, NULL, mThreadWrite, iDeviceObject );  // ½ϵͳ߳
									ZwClose( mThreadHandle );  // رվ
									for ( mReturn = 0; mReturn < 50; mReturn ++ ) {
										if ( mDeviceExtension -> DnThreadBuffer ) break;
										mDelay20mS( );
									}
									mStatus = mReturn >= 50 ? STATUS_UNSUCCESSFUL : STATUS_SUCCESS;
									mReturn = 0;
								}
								else mClearDnBufferData( iDeviceObject );  // Ѵ建
							}
							else mStatus = STATUS_NO_SUCH_DEVICE ;  // ܵЧ,豸Ч
							break;
						default:
							mStatus = STATUS_INVALID_PARAMETER;  // ش
							break;
					}
					mReturn = sizeof( ULONG );  // ݳ
					break;
				default:  // ֵ֧
					mStatus = STATUS_INVALID_PARAMETER;  // ش
					break;
			}
			mWin32Command -> mStatus = mStatus;  // ز״̬
			mWin32Command -> mLength = mReturn;  // ʵʴ䳤
			mReturn += mWIN32_COMMAND_HEAD;  // ͷȵ÷ݵܳ
		}
		else {  // ʧ
			if ( mUrb == NULL ) mStatus = STATUS_INSUFFICIENT_RESOURCES;  // Դ
			else mStatus = STATUS_BUFFER_TOO_SMALL;  // ̫С
		}
		if ( mUrb != NULL ) {
			if ( mUrb == & mDeviceExtension -> mExtPublicUrb ) mDeviceExtension -> mExtUrbBuffer = mUrb;
			else ExFreePool( mUrb );  // ͷڴ
		}
		if ( mStatus != STATUS_PENDING ) {  // ɹػʧܷ
			iIrp -> IoStatus.Status = mStatus;  // ״̬
			iIrp -> IoStatus.Information = mReturn;  // ݵĳ
			IoCompleteRequest( iIrp, IO_CH375_INCREMENT );  // ,ȼ
		}
	}
	else {  // ֱӴ¼豸
		IoSkipCurrentIrpStackLocation( iIrp );  // ֱӴ͵ǰջ
		mStatus = IoCallDriver( mDeviceExtension -> mExtNextLowerDevice, iIrp );  // ¼豸
	}
	InterlockedDecrement( & mDeviceExtension -> mExtIoCount );  // 
	return( mStatus );
}

NTSTATUS	mRequestPipe(  // ִָܵ
	PDEVICE_OBJECT	iDeviceObject,
	USHORT			iFunction,
	ULONG			iPipe )
{
	PURB				mUrb;
	NTSTATUS			mStatus;
	mPDEVICE_EXTENSION	mDeviceExtension = iDeviceObject -> DeviceExtension;  // 豸չ
	mUrb = ExAllocatePool( NonPagedPool, sizeof( URB ) );  // ڴΪURB
	if ( mUrb == NULL ) return( STATUS_INSUFFICIENT_RESOURCES );  // Դ
	mUrb -> UrbHeader.Length = sizeof( struct _URB_PIPE_REQUEST );
	mUrb -> UrbHeader.Function = iFunction;
	switch( iPipe ) {  // ָܵ
		case mPipeInterUp:  // CH375жϴܵ
			mUrb -> UrbPipeRequest.PipeHandle = mDeviceExtension -> mExtInterUpPipe;
			break;
		case mPipeAuxDown:  // CH375ĸ´ܵ
			mUrb -> UrbPipeRequest.PipeHandle = mDeviceExtension -> mExtAuxDownPipe;
			break;
		case mPipeDataUp:  // CH375ݿϴܵ
			mUrb -> UrbPipeRequest.PipeHandle = mDeviceExtension -> mExtDataUpPipe;
			break;
		case mPipeDataDown:  // CH375ݿ´ܵ
			mUrb -> UrbPipeRequest.PipeHandle = mDeviceExtension -> mExtDataDownPipe;
			break;
		default:  // ֧
			mUrb -> UrbPipeRequest.PipeHandle = NULL;  // ܵЧ
			break;
	}
	if ( mUrb -> UrbPipeRequest.PipeHandle == NULL ) mStatus = STATUS_NO_SUCH_DEVICE ;  // ܵЧ
	else {
		mStatus = mUsbSubmitUrb( iDeviceObject, mUrb );  // ύURB
		if ( ! NT_SUCCESS( mStatus ) ) {
			if ( mStatus != STATUS_CANCELLED && mStatus != STATUS_DEVICE_NOT_CONNECTED ) {
				if ( iFunction != URB_FUNCTION_RESET_PIPE ) {
					mUrb -> UrbHeader.Length = sizeof( struct _URB_PIPE_REQUEST );
					mUrb -> UrbHeader.Function = URB_FUNCTION_RESET_PIPE;
					mStatus = mUsbSubmitUrb( iDeviceObject, mUrb );  // ύURB
				}
				if ( ! NT_SUCCESS( mStatus ) ) mResetUsbDevice( iDeviceObject );
			}
		}
	}
	ExFreePool( mUrb );  // ͷڴ
	return( mStatus );
}

VOID		mCancelCurrentInter(  // ȡǰжϴIRP
	PDEVICE_OBJECT	iDeviceObject,
	PIRP			iIrp )
{
	mPDEVICE_EXTENSION	mDeviceExtension = iDeviceObject -> DeviceExtension;  // 豸չ
	mDeviceExtension -> mExtInterStartTime.u.HighPart = 0x87654321;
	KeSetEvent( & mDeviceExtension -> mExtThreadToutEvent, EVENT_INCREMENT, FALSE );  // ߳¼
	IoReleaseCancelSpinLock( iIrp -> CancelIrql );
}

VOID		mCancelCurrentAux(  // ȡǰ´IRP
	PDEVICE_OBJECT	iDeviceObject,
	PIRP			iIrp )
{
	mPDEVICE_EXTENSION	mDeviceExtension = iDeviceObject -> DeviceExtension;  // 豸չ
	mDeviceExtension -> mExtAuxStartTime.u.HighPart = 0x87654321;
	KeSetEvent( & mDeviceExtension -> mExtThreadToutEvent, EVENT_INCREMENT, FALSE );  // ߳¼
	IoReleaseCancelSpinLock( iIrp -> CancelIrql );
}

VOID		mCancelCurrentUp(  // ȡǰϴIRP
	PDEVICE_OBJECT	iDeviceObject,
	PIRP			iIrp )
{
	mPDEVICE_EXTENSION	mDeviceExtension = iDeviceObject -> DeviceExtension;  // 豸չ
	mDeviceExtension -> mExtUpStartTime.u.HighPart = 0x87654321;
	KeSetEvent( & mDeviceExtension -> mExtThreadToutEvent, EVENT_INCREMENT, FALSE );  // ߳¼
	IoReleaseCancelSpinLock( iIrp -> CancelIrql );
}

VOID		mCancelCurrentDown(  // ȡǰ´IRP
	PDEVICE_OBJECT	iDeviceObject,
	PIRP			iIrp )
{
	mPDEVICE_EXTENSION	mDeviceExtension = iDeviceObject -> DeviceExtension;  // 豸չ
	mDeviceExtension -> mExtDownStartTime.u.HighPart = 0x87654321;
	KeSetEvent( & mDeviceExtension -> mExtThreadToutEvent, EVENT_INCREMENT, FALSE );  // ߳¼
	IoReleaseCancelSpinLock( iIrp -> CancelIrql );
}

NTSTATUS	mDispatchCleanup(  // ȡ
	PDEVICE_OBJECT	iDeviceObject,
	PIRP			iIrp )
{
	ULONG				i;
	mPDEVICE_EXTENSION	mDeviceExtension = iDeviceObject -> DeviceExtension;  // 豸չ
	if ( mDeviceExtension -> mExtIoCount != 0 && mDeviceExtension -> mExtDeviceOpen <= 1 ) {  // δɵĲ
		for ( i = 0; i < 10; i ++ ) {  /* ȡδUSBͨѶ */
			PURB			mUrb;
			if ( mDeviceExtension -> mExtIoCount == 0 ) break;  /*  */
			mDeviceExtension -> mExtInterStartTime.u.HighPart = 0x87654321;
			mDeviceExtension -> mExtAuxStartTime.u.HighPart = 0x87654321;
			mDeviceExtension -> mExtUpStartTime.u.HighPart = 0x87654321;
			mDeviceExtension -> mExtDownStartTime.u.HighPart = 0x87654321;
			KeSetEvent( & mDeviceExtension -> mExtThreadToutEvent, EVENT_INCREMENT, FALSE );  // ߳¼
			mDelay20mS( );
			if ( mDeviceExtension -> mExtIoCount == 0 ) break;  /*  */
			if ( i > 5 ) {  /* ǿȡ */
				if ( mDeviceExtension -> mExtUsbDownCount ) mRequestPipe( iDeviceObject, URB_FUNCTION_ABORT_PIPE, mPipeDataDown );  // ´ִܵȡ
				if ( mDeviceExtension -> mExtUsbUpCount ) mRequestPipe( iDeviceObject, URB_FUNCTION_ABORT_PIPE, mPipeDataUp );  // ϴִܵȡ
				if ( mDeviceExtension -> mExtUsbAuxCount ) mRequestPipe( iDeviceObject, URB_FUNCTION_ABORT_PIPE, mPipeAuxDown );  // ȡ
				if ( mDeviceExtension -> mExtUsbInterCount ) mRequestPipe( iDeviceObject, URB_FUNCTION_ABORT_PIPE, mPipeInterUp );  // ȡ
			}
			if ( mIsDeviceExist( iDeviceObject, STATUS_SUCCESS ) == FALSE ) break;  // 豸ѾƳ
		}
	}
	if ( mDeviceExtension -> mExtUsbDownCount ) mRequestPipe( iDeviceObject, URB_FUNCTION_RESET_PIPE, mPipeDataDown );  // ´ִܵȡ
	if ( mDeviceExtension -> mExtUsbUpCount ) mRequestPipe( iDeviceObject, URB_FUNCTION_RESET_PIPE, mPipeDataUp );  // ϴִܵȡ
	if ( mDeviceExtension -> mExtUsbAuxCount ) mRequestPipe( iDeviceObject, URB_FUNCTION_RESET_PIPE, mPipeAuxDown );  // ȡ
	if ( mDeviceExtension -> mExtUsbInterCount ) mRequestPipe( iDeviceObject, URB_FUNCTION_RESET_PIPE, mPipeInterUp );  // ȡ
	iIrp -> IoStatus.Status = STATUS_SUCCESS;  // سɹ
	iIrp -> IoStatus.Information = 0;
	IoCompleteRequest( iIrp, IO_NO_INCREMENT );  // 
	return( STATUS_SUCCESS );  // ״̬
}

NTSTATUS	mDispatchPower(  // Դ
	PDEVICE_OBJECT	iDeviceObject,
	PIRP			iIrp )
{
	NTSTATUS				mStatus;
	BOOLEAN					mCompletion;
	POWER_STATE				mPowerState;
	mPDEVICE_EXTENSION		mDeviceExtension;
	PIO_STACK_LOCATION		mCurrentIrpStack;
	mDeviceExtension = iDeviceObject -> DeviceExtension;  // 豸չ
	mCompletion = FALSE;  // ԤΪδ
	mCurrentIrpStack = IoGetCurrentIrpStackLocation( iIrp );  // ǰջԪָ
	switch ( mCurrentIrpStack -> Parameters.Power.Type ) {  // Դ
		case DevicePowerState:
			if ( mCurrentIrpStack -> MinorFunction == IRP_MN_SET_POWER ) {
				switch ( mCurrentIrpStack -> Parameters.Power.State.DeviceState ) {
					case PowerDeviceD0:
						mDeviceExtension -> mPowerState = PowerDeviceD0;
						IoMarkIrpPending( iIrp );
						IoCopyCurrentIrpStackLocationToNext( iIrp );  // ƵǰջԪ
						mDeviceExtension -> mDevPowerIrp = iIrp;
						IoSetCompletionRoutine( iIrp, mDevPwrCompletRoutine, iIrp, TRUE, TRUE, TRUE );  // 趨
						mStatus = PoCallDriver( mDeviceExtension -> mExtNextLowerDevice, iIrp );  // ¼豸
						mCompletion = TRUE;  // Ѿ
						break;
					case PowerDeviceD3:
						mDeviceExtension -> mPowerState = PowerDeviceD3;
						mDeviceExtension -> mExtDeviceStart = FALSE;  // 豸־
						PoSetPowerState( iDeviceObject, DevicePowerState, mCurrentIrpStack -> Parameters.Power.State );
						IoMarkIrpPending( iIrp );
						mDeviceExtension -> mDevPowerIrp = iIrp;
						KeSetEvent( & mDeviceExtension -> ThreadPowerEvent, EVENT_INCREMENT, FALSE );  // ߳¼
						mCompletion = TRUE;  // Ѿ
						break;
					default:
						break;
				}
			}
			break;
		case SystemPowerState:
			switch ( mCurrentIrpStack -> MinorFunction ) {
				case IRP_MN_SET_POWER:
					switch ( mCurrentIrpStack -> Parameters.Power.State.SystemState ) {
						case PowerSystemMaximum:
						case PowerSystemWorking:
							mPowerState.DeviceState = PowerDeviceD0;
//							mDeviceExtension -> mPowerState = PowerDeviceD0;
							IoMarkIrpPending( iIrp );
							IoCopyCurrentIrpStackLocationToNext( iIrp );  // ƵǰջԪ
							IoSetCompletionRoutine( iIrp, mSysPwrCompletRoutine, &mPowerState, TRUE, TRUE, TRUE );  // 趨
							mStatus = PoCallDriver( mDeviceExtension -> mExtNextLowerDevice, iIrp );  // ¼豸
							mCompletion = TRUE;  // Ѿ
							break;
						case PowerSystemSleeping1:
						case PowerSystemSleeping2:
						case PowerSystemSleeping3:
						case PowerSystemHibernate:
						case PowerSystemShutdown:
							mPowerState.DeviceState = PowerDeviceD3;
//							mDeviceExtension -> mPowerState = PowerDeviceD3;
							IoMarkIrpPending( iIrp );
							IoCopyCurrentIrpStackLocationToNext( iIrp );  // ƵǰջԪ
							IoSetCompletionRoutine( iIrp, mSysPwrCompletRoutine, &mPowerState, TRUE, TRUE, TRUE );  // 趨
							mStatus = PoCallDriver( mDeviceExtension -> mExtNextLowerDevice, iIrp );  // ¼豸
							mCompletion = TRUE;  // Ѿ
							break;
						default:
							break;
					}
					break;
				default:
					break;
			}
			break;
		default:
			break;
	}
	if ( mCompletion == FALSE ) {
		PoStartNextPowerIrp( iIrp );  // ʼһ
		IoSkipCurrentIrpStackLocation( iIrp );  // ֱӴ͵ǰջ
		mStatus = PoCallDriver( mDeviceExtension -> mExtNextLowerDevice, iIrp );  // ¼豸
	}
	else {
		mStatus = STATUS_PENDING;
	}
	return( mStatus );
}

NTSTATUS	mSysPwrCompletRoutine(  // 
	PDEVICE_OBJECT	iDeviceObject,
	PIRP			iIrp,
	PPOWER_STATE	iPowerState )  // 
{
	mPDEVICE_EXTENSION	mDeviceExtension = iDeviceObject -> DeviceExtension;  // 豸չ
	if ( iIrp -> PendingReturned ) IoMarkIrpPending( iIrp );
	PoRequestPowerIrp( mDeviceExtension -> mExtPhysicalTarget, IRP_MN_SET_POWER, *iPowerState, mSysPwrReqCompletion, iIrp, NULL );
	return( STATUS_MORE_PROCESSING_REQUIRED );  // ֹǰIRP
}

VOID		mSysPwrReqCompletion(
	PDEVICE_OBJECT		iDeviceObject,
	UCHAR				iMinorFunction,
	POWER_STATE			iPowerState,
	PIRP				iIrp,
	PIO_STATUS_BLOCK	iIoStatus )
{
	PoStartNextPowerIrp( iIrp );  // ʼһ
	IoCompleteRequest( iIrp, IO_NO_INCREMENT );  // ɵǰIRP
}

NTSTATUS	mDevPwrCompletRoutine(  // 
	PDEVICE_OBJECT	iDeviceObject,
	PIRP			iIrp,
	PVOID			iContext )  // 
{
	mPDEVICE_EXTENSION	mDeviceExtension = iDeviceObject -> DeviceExtension;  // 豸չ
	if ( iIrp -> PendingReturned ) IoMarkIrpPending( iIrp );
	if ( iContext ) {
		KeSetEvent( & mDeviceExtension -> ThreadPowerEvent, EVENT_INCREMENT, FALSE );  // ߳¼
	}
	else {
		PoStartNextPowerIrp( iIrp );  // ʼһ
		IoCompleteRequest( iIrp, IO_NO_INCREMENT );  // ɵǰIRP
	}
	return( STATUS_MORE_PROCESSING_REQUIRED );  // ֹǰIRP
}

VOID		mThreadDevPower(  // ϵͳ߳
	PVOID	iContext )
{
	ULONG				i;
	PIRP				mIrp;
	NTSTATUS			mStatus;
	POWER_STATE			mPowerState;
	PDEVICE_OBJECT		mDeviceObject;
	mPDEVICE_EXTENSION	mDeviceExtension;
	mDeviceObject = (PDEVICE_OBJECT)iContext;  // 豸
	mDeviceExtension = mDeviceObject -> DeviceExtension;  // 豸չ
	InterlockedIncrement( & mDeviceExtension -> mThreadCount );
	KeSetPriorityThread( KeGetCurrentThread(), LOW_REALTIME_PRIORITY );  // 趨ǰ߳Ϊʵʱȼ
	while ( mDriverObject != NULL && mDeviceExtension -> mExtDeviceRemove == FALSE ) {
		KeWaitForSingleObject( & mDeviceExtension -> ThreadPowerEvent, Executive, KernelMode, FALSE, NULL );
		if ( mDeviceExtension -> mExtDeviceRemove ) break;
		mIrp = InterlockedExchangePointer( & mDeviceExtension -> mDevPowerIrp, NULL );
		if ( mIrp != NULL && mDeviceExtension -> mPowerState == PowerDeviceD3 ) {
//			IoSetDeviceInterfaceState( & mDeviceExtension -> mSymbolicName, FALSE );  // 豸ӿ
			KeClearEvent( & mDeviceExtension -> ThreadStartEvent );  // ¼
			KeClearEvent( & mDeviceExtension -> DnThreadStartEvent );  // ¼
			for ( i = 0; i < 30; i ++ ) {
				if ( mDeviceExtension -> ThreadUsbCount == 0 && mDeviceExtension -> DnThreadUsbCount == 0 ) break;
				if ( mDeviceExtension -> ThreadUsbCount ) mRequestPipe( mDeviceObject, (USHORT)( i > 24 ? URB_FUNCTION_RESET_PIPE : URB_FUNCTION_ABORT_PIPE ), mPipeDataUp );  // ȡ
				if ( mDeviceExtension -> DnThreadUsbCount ) mRequestPipe( mDeviceObject, (USHORT)( i > 24 ? URB_FUNCTION_RESET_PIPE : URB_FUNCTION_ABORT_PIPE ), mPipeDataDown );  // ȡ
				if ( i == 10 || i == 20 ) KeSetEvent( & mDeviceExtension -> mExtThreadToutEvent, EVENT_INCREMENT, FALSE );  // ߳¼
				mDelay20mS( );
			}
			mDeactiveConfig( mDeviceObject, NULL );  // ȥ
			IoCopyCurrentIrpStackLocationToNext( mIrp );  // ƵǰջԪ
			IoSetCompletionRoutine( mIrp, mDevPwrCompletRoutine, NULL, TRUE, TRUE, TRUE );  // 趨
			mStatus = PoCallDriver( mDeviceExtension -> mExtNextLowerDevice, mIrp );  // ¼豸
		}
		else if ( mIrp != NULL && mDeviceExtension -> mPowerState == PowerDeviceD0 ) {
			for ( i = 0; i < 8; i ++ ) {
				if ( i ) {
					mDelay20mS( );
					if ( i == 6 ) { mDelay20mS( ); mDelay20mS( ); mDelay20mS( ); }
				}
				mDeviceExtension -> mDeviceGone = FALSE;
				if ( mIsDeviceExist( mDeviceObject, STATUS_SUCCESS ) ) break;
			}
			mStatus = mActiveConfig( mDeviceObject, NULL );  // 
			if ( ! NT_SUCCESS( mStatus ) ) {
				mDelay20mS( );
				mStatus = mActiveConfig( mDeviceObject, NULL );  // ¼
			}
			mDeviceExtension -> mExtDeviceStart = TRUE;
			KeSetEvent( & mDeviceExtension -> mExtThreadToutEvent, EVENT_INCREMENT, FALSE );  // ߳¼
			KeSetEvent( & mDeviceExtension -> ThreadStartEvent, EVENT_INCREMENT, FALSE );  // ߳¼
			KeSetEvent( & mDeviceExtension -> DnThreadStartEvent, EVENT_INCREMENT, FALSE );  // ߳¼
			PoStartNextPowerIrp( mIrp );  // ʼһ
			IoCompleteRequest( mIrp, IO_NO_INCREMENT );  // ɵǰIRP
//			IoSetDeviceInterfaceState( & mDeviceExtension -> mSymbolicName, TRUE );  // 豸ӿ
			mPowerState.DeviceState = PowerDeviceD0;
			PoSetPowerState ( mDeviceObject, DevicePowerState, mPowerState );
		}
	}
	InterlockedDecrement( & mDeviceExtension -> mThreadCount );
	PsTerminateSystemThread( STATUS_SUCCESS );  // ֹϵͳ߳
}

NTSTATUS	mDispatchSystemControl(  // ϵͳWMI
	PDEVICE_OBJECT	iDeviceObject,
	PIRP			iIrp )
{
	mPDEVICE_EXTENSION	mDeviceExtension = iDeviceObject -> DeviceExtension;  // 豸չ
	IoSkipCurrentIrpStackLocation( iIrp );  // ֱӴ͵ǰջ
	return( IoCallDriver( mDeviceExtension -> mExtNextLowerDevice, iIrp ) );  // ¼豸
}

NTSTATUS	mDispatchPnp(  // 弴
	PDEVICE_OBJECT	iDeviceObject,
	PIRP			iIrp )
{
	ULONG				i, mCompletion;  // 0:´, 1:, 2:״̬
	NTSTATUS			mStatus;
	PDEVICE_OBJECT		mNextDeviceObject;
	mPDEVICE_EXTENSION	mDeviceExtension = iDeviceObject -> DeviceExtension;  // 豸չ
	mNextDeviceObject = mDeviceExtension -> mExtNextLowerDevice ;
	mCompletion = 0;  // ԤΪ´
	switch( IoGetCurrentIrpStackLocation( iIrp ) -> MinorFunction ) {  // PnPӹܴ
		case IRP_MN_START_DEVICE:  // 豸
			mStatus = mWaitCompletion( iDeviceObject, iIrp );  // ȴIRP
			if ( NT_SUCCESS( mStatus ) ) {  // 豸
				mStatus = mActiveConfig( iDeviceObject, iIrp );  // 豸򼤻
				if ( ! NT_SUCCESS( mStatus ) ) mStatus = mActiveConfig( iDeviceObject, iIrp );  // ¼
				if ( NT_SUCCESS( mStatus ) ) {  // 豸
					mDeviceExtension -> mPowerState = PowerDeviceD0;
					mDeviceExtension -> mExtDeviceStart = TRUE;  // 豸־
					mDeviceExtension -> mExtDeviceRemove = FALSE;  // 豸Ƴ־
					KeSetEvent( & mDeviceExtension -> mExtThreadToutEvent, EVENT_INCREMENT, FALSE );  // ߳¼
					KeSetEvent( & mDeviceExtension -> ThreadStartEvent, EVENT_INCREMENT, FALSE );  // ߳¼
					KeSetEvent( & mDeviceExtension -> DnThreadStartEvent, EVENT_INCREMENT, FALSE );  // ߳¼
					IoSetDeviceInterfaceState( & mDeviceExtension -> mExtDeviceName, TRUE );  // 豸ӿ
				}
			}
			mCompletion = 1;  // Ѿ
			break;
		case IRP_MN_QUERY_STOP_DEVICE:  // Ҫֹͣ豸
			if ( mDeviceExtension -> mExtIoCount != 0 ) {  // ǰڲ
				mStatus = STATUS_UNSUCCESSFUL;  // ޷ֹͣ,ʧ
				iIrp -> IoStatus.Information = 0;
				mCompletion = 1;  // ǿƲ
			}
			else mDeviceExtension -> mExtDeviceStart = FALSE;  // 豸־
			break;
		case IRP_MN_CANCEL_STOP_DEVICE:  // ȡֹͣ豸
			mDeviceExtension -> mExtDeviceStart = TRUE;  // ָ豸־
			KeSetEvent( & mDeviceExtension -> mExtThreadToutEvent, EVENT_INCREMENT, FALSE );  // ߳¼
			KeSetEvent( & mDeviceExtension -> ThreadStartEvent, EVENT_INCREMENT, FALSE );  // ߳¼
			KeSetEvent( & mDeviceExtension -> DnThreadStartEvent, EVENT_INCREMENT, FALSE );  // ߳¼
			break;
		case IRP_MN_STOP_DEVICE:  // ֹͣ豸
			mDeviceExtension -> mExtDeviceStart = FALSE;  // 豸־
			mDeactiveConfig( iDeviceObject, iIrp );  // ȥ
			break;
		case IRP_MN_QUERY_REMOVE_DEVICE:  // ҪƳ豸
			if ( mDeviceExtension -> mExtDeviceOpen != 0 ||  // 򿪼Ϊ0δر
				 mDeviceExtension -> mExtIoCount != 0 ) {  // ߵǰڲ
				mStatus = STATUS_UNSUCCESSFUL;  // ޷Ƴ,ʧ
				iIrp -> IoStatus.Information = 0;
				mCompletion = 1;  // ǿƲ
			}
			else {  // δ豸
				mDeviceExtension -> mExtDeviceRemove = TRUE;  // 豸Ƴ־
				IoSetDeviceInterfaceState( & mDeviceExtension -> mExtDeviceName, FALSE );  // 豸ӿ
			}
			break;
		case IRP_MN_CANCEL_REMOVE_DEVICE:  // ȡƳ豸
			mDeviceExtension -> mExtDeviceRemove = FALSE;  // 豸Ƴ־
			IoSetDeviceInterfaceState( & mDeviceExtension -> mExtDeviceName, TRUE );  // ָ豸ӿ
			break;
		case IRP_MN_SURPRISE_REMOVAL:  // Ƴ豸
			mDeviceExtension -> mExtDeviceRemove = TRUE;  // 豸Ƴ־
			IoSetDeviceInterfaceState( & mDeviceExtension -> mExtDeviceName, FALSE );  // 豸ӿ
			break;
		case IRP_MN_REMOVE_DEVICE:  // Ƴ豸
			mDeviceExtension -> mExtDeviceRemove = TRUE;  // 豸Ƴ־
			IoSetDeviceInterfaceState( & mDeviceExtension -> mExtDeviceName, FALSE );  // 豸ӿ
			mDeviceExtension -> mExtDeviceStart = FALSE;  // 豸־
			mDeviceExtension -> mExtDownStartTime.u.HighPart = 0x87654321;
			mDeviceExtension -> mExtUpStartTime.u.HighPart = 0x87654321;
			mDeviceExtension -> mExtAuxStartTime.u.HighPart = 0x87654321;
			mDeviceExtension -> mExtInterStartTime.u.HighPart = 0x87654321;
			mDeviceExtension -> ThreadBufSize = 0;  // ǿ˳
			mDeviceExtension -> DnThreadBufSize = 0;  // ǿ˳
			KeSetEvent( & mDeviceExtension -> mExtThreadToutEvent, EVENT_INCREMENT, FALSE );  // ߳¼
			KeSetEvent( & mDeviceExtension -> ThreadStartEvent, IO_CH375_INCREMENT, FALSE );  // ߳¼
			KeSetEvent( & mDeviceExtension -> DnThreadStartEvent, IO_CH375_INCREMENT, FALSE );  // ߳¼
			for ( i = 0; i < 10; i ++ ) {  /* ȡδUSBͨѶ */
				if ( mDeviceExtension -> mExtIoCount == 0 ) break;  /*  */
				if ( i >= 5 ) {  /* ǿȡ */
					if ( mDeviceExtension -> mExtUsbDownCount ) mRequestPipe( iDeviceObject, (USHORT)( i >= 8 ? URB_FUNCTION_RESET_PIPE : URB_FUNCTION_ABORT_PIPE ), mPipeDataDown );  // ´ִܵȡ
					if ( mDeviceExtension -> mExtUsbUpCount ) mRequestPipe( iDeviceObject, (USHORT)( i >= 8 ? URB_FUNCTION_RESET_PIPE : URB_FUNCTION_ABORT_PIPE ), mPipeDataUp );  // ϴִܵȡ
					if ( mDeviceExtension -> mExtUsbAuxCount ) mRequestPipe( iDeviceObject, (USHORT)( i >= 8 ? URB_FUNCTION_RESET_PIPE : URB_FUNCTION_ABORT_PIPE ), mPipeAuxDown );  // ڸ´ִܵȡ
					if ( mDeviceExtension -> mExtUsbInterCount ) mRequestPipe( iDeviceObject, (USHORT)( i >= 8 ? URB_FUNCTION_RESET_PIPE : URB_FUNCTION_ABORT_PIPE ), mPipeInterUp );  // жϴִܵȡ
				}
				mDelay20mS( );
				if ( mDeviceExtension -> mExtIoCount == 0 ) break;  /*  */
			}
			while ( ! NT_SUCCESS( mExitThreadRead( iDeviceObject ) ) );
			while ( ! NT_SUCCESS( mExitThreadWrite( iDeviceObject ) ) );
			for ( i = 0; i < 10; i ++ ) {
				if ( mDeviceExtension -> mThreadCount == 0 ) break;
				KeSetEvent( & mDeviceExtension -> mExtThreadToutEvent, IO_CH375_INCREMENT, FALSE );  // ߳¼
				KeSetEvent( & mDeviceExtension -> ThreadPowerEvent, IO_CH375_INCREMENT, FALSE );  // ߳¼
				if ( mDeviceExtension -> mThreadCount == 0 ) break;
				mDelay20mS( );
			}
			mDeactiveConfig( iDeviceObject, iIrp );  // ȥ
			if ( i >= 10 ) mResetUsbDevice( iDeviceObject );
			mRemoveDevice( iDeviceObject );  // Ƴ豸
//			IoSkipCurrentIrpStackLocation( iIrp );  // ֱӴ͵ǰջ
//			mStatus = IoCallDriver( mNextDeviceObject, iIrp );  // ¼豸
//			mCompletion = 2;  // Ѿ,״̬
			break;
		case IRP_MN_QUERY_CAPABILITIES: {
			/*PDEVICE_CAPABILITIES	DevCap;
			DevCap = IoGetCurrentIrpStackLocation( iIrp ) -> Parameters.DeviceCapabilities.Capabilities;
//			DevCap -> Version = 1;
//			DevCap -> Size = sizeof( DEVICE_CAPABILITIES );
			DevCap -> SystemWake = PowerSystemUnspecified;
			DevCap -> DeviceWake = PowerDeviceUnspecified;
			DevCap -> D1Latency = 0;
			DevCap -> D2Latency = 0;
			DevCap -> D3Latency = 0;
			DevCap -> LockSupported = FALSE;
			DevCap -> EjectSupported = FALSE;
			DevCap -> Removable = TRUE;
			DevCap -> DockDevice = FALSE;
//			DevCap -> UniqueID = TRUE;
			DevCap -> UniqueID = FALSE;
			DevCap -> SilentInstall = TRUE;  //?
			DevCap -> SurpriseRemovalOK = TRUE;  //?
//98			DevCap -> NoDisplayInUI = FALSE ;
//			DevCap -> RawDeviceOK = TRUE;
			mStatus = STATUS_SUCCESS;
			mCompletion = 1;  // Ѿ
			break;*/
			PDEVICE_CAPABILITIES DevCap;
                        DevCap = IoGetCurrentIrpStackLocation( iIrp ) -> Parameters.DeviceCapabilities.Capabilities;
                        //   DevCap -> Version = 1;
                        //   DevCap -> Size = sizeof( DEVICE_CAPABILITIES );
                        DevCap -> SystemWake = PowerSystemUnspecified;
                        DevCap -> DeviceWake = PowerDeviceUnspecified;
                        DevCap -> D1Latency = 0;
                        DevCap -> D2Latency = 0;
                        DevCap -> D3Latency = 0;
                        DevCap -> LockSupported = FALSE;
                        DevCap -> EjectSupported = FALSE;
                        DevCap -> Removable = TRUE;
                        DevCap -> DockDevice = FALSE;
                        //   DevCap -> UniqueID = TRUE;
                        DevCap -> UniqueID = FALSE;
                        DevCap -> SilentInstall = TRUE;  //?
                        DevCap -> SurpriseRemovalOK = TRUE;  //?
                        //98  DevCap -> NoDisplayInUI = FALSE ;
                        //   DevCap -> RawDeviceOK = TRUE;
                        mStatus = mWaitCompletion(iDeviceObject,iIrp);
                        //   DevCap -> Version = 1;
                        //   DevCap -> Size = sizeof( DEVICE_CAPABILITIES );
                        DevCap -> SystemWake = PowerSystemUnspecified;
                        DevCap -> DeviceWake = PowerDeviceUnspecified;
                        DevCap -> D1Latency = 0;
                        DevCap -> D2Latency = 0;
                        DevCap -> D3Latency = 0;
                        DevCap -> LockSupported = FALSE;
                        DevCap -> EjectSupported = FALSE;
                        DevCap -> Removable = TRUE;
                        DevCap -> DockDevice = FALSE;
                        //   DevCap -> UniqueID = TRUE;
                        DevCap -> UniqueID = FALSE;
                        DevCap -> SilentInstall = TRUE;  //?
                        DevCap -> SurpriseRemovalOK = TRUE;  //?
                        //98   DevCap -> NoDisplayInUI = FALSE ;
                        //   DevCap -> RawDeviceOK = TRUE;
                        //mStatus = STATUS_SUCCESS;
                        mCompletion = 1;  // Ѿ
                        break;
		}
		default:
			break;
	}
	if ( mCompletion == 0 ) {  // δ´
		IoSkipCurrentIrpStackLocation( iIrp );  // ֱӴ͵ǰջ
		mStatus = IoCallDriver( mNextDeviceObject, iIrp );  // ¼豸
	}
	else if ( mCompletion == 1 ) {  // Ѿ
		iIrp -> IoStatus.Status = mStatus;  // ״̬
		IoCompleteRequest( iIrp, IO_NO_INCREMENT );  // ɵǰIRP
	}
	return( mStatus );
}

NTSTATUS	mWaitCompletion(  // ȴIRP
	PDEVICE_OBJECT	iDeviceObject,
	PIRP			iIrp )
{
	KEVENT				mEvent;
	NTSTATUS			mStatus;
	mPDEVICE_EXTENSION	mDeviceExtension = iDeviceObject -> DeviceExtension;  // 豸չ
	KeInitializeEvent( &mEvent, NotificationEvent, FALSE );  // ʼIRP¼ΪЧ
	IoCopyCurrentIrpStackLocationToNext( iIrp );  // ƵǰջԪ
	IoSetCompletionRoutine( iIrp, mCompletionRoutine, &mEvent, TRUE, TRUE, TRUE );  // 趨
	mStatus = IoCallDriver( mDeviceExtension -> mExtNextLowerDevice, iIrp );  // ¼豸
	if ( mStatus == STATUS_PENDING ) {  // ȴҵIO
		KeWaitForSingleObject( &mEvent, Executive, KernelMode, FALSE, NULL );  // ȴIRP
		mStatus = iIrp -> IoStatus.Status;  // ȡ״̬
	}
	return( mStatus );  // ״̬
}

NTSTATUS	mCompletionRoutine(  // 
	PDEVICE_OBJECT	iDeviceObject,
	PIRP			iIrp,
	PVOID			iContext )  // ,¼
{
	KeSetEvent( (PKEVENT)iContext, IO_NO_INCREMENT, FALSE );  // ò¼
	return( STATUS_MORE_PROCESSING_REQUIRED );  // ֹǰIRP
}

NTSTATUS	mActiveConfig(  // 
	PDEVICE_OBJECT	iDeviceObject,
	PIRP			iIrp )
{
	ULONG							i;
	PURB							mUrb;
	NTSTATUS						mStatus;
	PUSB_CONFIGURATION_DESCRIPTOR	mConfigDescriptor;
	PUSB_INTERFACE_DESCRIPTOR		mInterfaceDescriptor;
	USBD_INTERFACE_LIST_ENTRY		mInterfaceList[2];
	PUSBD_INTERFACE_INFORMATION		mInterface;
	PUSBD_PIPE_INFORMATION			mPipe;
	mPDEVICE_EXTENSION				mDeviceExtension = iDeviceObject -> DeviceExtension;  // 豸չ
	mStatus = STATUS_INSUFFICIENT_RESOURCES;  // Ԥòʧ
	mDeviceExtension -> mExtInterUpPipe = NULL;
	mDeviceExtension -> mExtAuxDownPipe = NULL;
	mDeviceExtension -> mExtDataUpPipe = NULL;
	mDeviceExtension -> mExtDataDownPipe = NULL;
	mConfigDescriptor = ExAllocatePool( NonPagedPool,  // ڴΪURB
										256 + sizeof( URB ) );
	if ( mConfigDescriptor != NULL ) {  // ڴ
		mUrb = (PURB) ( (PUCHAR)mConfigDescriptor + 256 );  // ָURB,ǰ256ֽڱ
		UsbBuildGetDescriptorRequest( mUrb, sizeof( struct _URB_CONTROL_DESCRIPTOR_REQUEST ),  // ȡURB
									  USB_CONFIGURATION_DESCRIPTOR_TYPE, 0, 0, mConfigDescriptor, NULL,  // 
									  sizeof( USB_CONFIGURATION_DESCRIPTOR ), NULL );  // 
		mStatus = mUsbSubmitUrb( iDeviceObject, mUrb );  // ύURB
		if ( NT_SUCCESS( mStatus ) && mConfigDescriptor -> wTotalLength > 255 ) mStatus = STATUS_DEVICE_DATA_ERROR;
		if ( NT_SUCCESS( mStatus ) ) {  // ȡ
			UsbBuildGetDescriptorRequest( mUrb, sizeof(struct _URB_CONTROL_DESCRIPTOR_REQUEST ),  // ȡURB
										  USB_CONFIGURATION_DESCRIPTOR_TYPE, 0, 0, mConfigDescriptor, NULL,  // 
										  (ULONG)( mConfigDescriptor -> wTotalLength ), NULL );  // Ϣܳ
			mStatus = mUsbSubmitUrb( iDeviceObject, mUrb );  // ύURB
			if ( NT_SUCCESS( mStatus ) && mConfigDescriptor -> bNumInterfaces == 0 )  // ȡǲ
				mStatus = STATUS_DEVICE_DATA_ERROR;  // ӿЧ
			if ( NT_SUCCESS( mStatus ) ) {  // ȡҽӿЧ
				mInterfaceDescriptor = USBD_ParseConfigurationDescriptorEx( mConfigDescriptor, mConfigDescriptor,
																			-1, -1, -1, -1, -1 );  // ȡһӿ
				mInterfaceList[0].InterfaceDescriptor = mInterfaceDescriptor;  // ҪõĽӿб
				mInterfaceList[0].Interface = NULL;
				mInterfaceList[1].InterfaceDescriptor = NULL;  // б
				mInterfaceList[1].Interface = NULL;
				mUrb = USBD_CreateConfigurationRequestEx( mConfigDescriptor, mInterfaceList );  // URB
				if ( mUrb != NULL ) {  // URB
					mInterface = & mUrb -> UrbSelectConfiguration.Interface;  // ǰӿڵϢ
					for ( i = 0; i < mInterface -> NumberOfPipes; ++i ) {  // ж˵/ܵ
						mPipe = & mInterface -> Pipes[ i ];  // ָܵ
						if ( mPipe -> MaximumTransferSize > mMAX_BUFFER_LENGTH )  // ĬϵĳȽϴ
							mPipe -> MaximumTransferSize = mMAX_BUFFER_LENGTH;  // 󳤶
					}
					mStatus = mUsbSubmitUrb( iDeviceObject, mUrb );  // ύURB
					if ( NT_SUCCESS( mStatus ) ) {  // CH375оƬ
						mInterface = & mUrb -> UrbSelectConfiguration.Interface;  // ǰӿڵϢ
						for ( i = 0; i < mInterface -> NumberOfPipes; ++i ) {  // ж˵/ܵ
							mPipe = & mInterface -> Pipes[ i ];  // ָܵ
							if ( mPipe -> MaximumTransferSize > mMAX_BUFFER_LENGTH )  // ĬϵĳȽϴ
								mPipe -> MaximumTransferSize = mMAX_BUFFER_LENGTH;  // 󳤶
							switch( mPipe -> EndpointAddress ) {  // Ƚ϶˵ַ,ȷܵ
								case mCH375_ENDP_INTER_UP:  // жϴ˵ĵַ
									mDeviceExtension -> mExtInterUpPipe = mPipe -> PipeHandle;  // жϴܵľ
									break;
								case mCH375_ENDP_AUX_DOWN:  // ´˵ĵַ
									mDeviceExtension -> mExtAuxDownPipe = mPipe -> PipeHandle;  // 渨´ܵľ
									break;
								case mCH375_ENDP_DATA_UP:  // ݿϴ˵ĵַ
									mDeviceExtension -> mExtDataUpPipe = mPipe -> PipeHandle;  // ݿϴܵľ
									if ( mPipe -> MaximumPacketSize <= 8 ) mStatus = STATUS_NO_SUCH_DEVICE;  // CH375оƬ,豸Ч
									break;
								case mCH375_ENDP_DATA_DOWN:  // ݿ´˵ĵַ
									mDeviceExtension -> mExtDataDownPipe = mPipe -> PipeHandle;  // ݿ´ܵľ
									if ( mPipe -> MaximumPacketSize <= 8 ) mStatus = STATUS_NO_SUCH_DEVICE;  // CH375оƬ,豸Ч
									break;
							}
						}
					}
					ExFreePool( mUrb );  // ͷURBڴ
				}
				else mStatus = STATUS_INSUFFICIENT_RESOURCES;  // ޷URB
			}
		}
		ExFreePool( mConfigDescriptor );  // ͷڴ
	}
	return( mStatus );  // ״̬
}

NTSTATUS	mDeactiveConfig(  // ȥ
	PDEVICE_OBJECT	iDeviceObject,
	PIRP			iIrp )
{
	PURB				mUrb;
	mPDEVICE_EXTENSION	mDeviceExtension;
	NTSTATUS			mStatus = STATUS_INSUFFICIENT_RESOURCES;  // Ԥòʧ
	if ( mIsDeviceExist( iDeviceObject, STATUS_SUCCESS ) == FALSE ) return( STATUS_NO_SUCH_DEVICE );  // 豸ѾƳ
	mUrb = ExAllocatePool( NonPagedPool, sizeof( URB ) );  // USB
	if ( mUrb != NULL ) {  // USB
		UsbBuildSelectConfigurationRequest( mUrb, sizeof( struct _URB_SELECT_CONFIGURATION ), NULL );  // URB
		mStatus = mUsbSubmitUrb( iDeviceObject, mUrb );  // ύURB
		ExFreePool( mUrb );  // ͷURB
		mDeviceExtension = iDeviceObject -> DeviceExtension;  // 豸չ
		mDeviceExtension -> mExtInterUpPipe = NULL;
		mDeviceExtension -> mExtAuxDownPipe = NULL;
		mDeviceExtension -> mExtDataUpPipe = NULL;
		mDeviceExtension -> mExtDataDownPipe = NULL;
	}
	return( mStatus );  // ״̬
}

NTSTATUS	mUsbSubmitUrb(  // ύURB
	PDEVICE_OBJECT	iDeviceObject,
	PURB			iUrb )
{
	PIRP				mIrp;
	KEVENT				mEvent;
	mPDEVICE_EXTENSION	mDeviceExtension;
	IO_STATUS_BLOCK		mIoStatusBlock;
	NTSTATUS			mStatus = STATUS_INSUFFICIENT_RESOURCES;  // Ԥòʧ
	mDeviceExtension = iDeviceObject -> DeviceExtension;  // 豸չ
	InterlockedIncrement( & mDeviceExtension -> mExtIoCount );  // ,ֹ;ֹͣƳ豸
	KeInitializeEvent( &mEvent, NotificationEvent, FALSE );  // ʼIRP¼źΪЧ
	mIrp = IoBuildDeviceIoControlRequest( IOCTL_INTERNAL_USB_SUBMIT_URB, mDeviceExtension -> mExtNextLowerDevice,
										  NULL, 0, NULL, 0, TRUE, &mEvent, &mIoStatusBlock );  // IRPύURB
	if ( mIrp != NULL ) {  // IRPЧ
		IoGetNextIrpStackLocation( mIrp ) -> Parameters.Others.Argument1 = iUrb;  // URBΪݸ¼豸
		mStatus = IoCallDriver( mDeviceExtension -> mExtNextLowerDevice, mIrp );  // ¼豸IO
		if ( mStatus == STATUS_PENDING ) {  // ȴҵIO
			KeWaitForSingleObject( &mEvent, Executive, KernelMode, FALSE, NULL );  // ȴIRP
			mStatus = mIoStatusBlock.Status;  // ȡ״̬
		}
		if ( mStatus == STATUS_TIMEOUT ) mStatus = STATUS_IO_TIMEOUT;  // ת
	}
	InterlockedDecrement( & mDeviceExtension -> mExtIoCount );  // 
	return( mStatus );  // ״̬
}

BOOLEAN		mIsDeviceExist(  // ѯUSB豸Ƿ
	PDEVICE_OBJECT	iDeviceObject,
	NTSTATUS		iStatus )
{
	ULONG				mPortStatus;
	PIRP				mIrp;
	KEVENT				mEvent;
	mPDEVICE_EXTENSION	mDeviceExtension;
	IO_STATUS_BLOCK		mIoStatusBlock;
	NTSTATUS			mStatus;  // Ԥòʧ
	mDeviceExtension = iDeviceObject -> DeviceExtension;  // 豸չ
	if ( mDeviceExtension -> mDeviceGone ) return( FALSE );
	if ( iStatus == STATUS_NO_SUCH_DEVICE || iStatus == STATUS_DEVICE_DOES_NOT_EXIST
		|| iStatus == STATUS_DEVICE_NOT_CONNECTED
		|| iStatus == STATUS_NO_SUCH_FILE || iStatus == STATUS_DEVICE_OFF_LINE ) {
			mDeviceExtension -> mDeviceGone = TRUE;  // 豸ѾƳ
			return( FALSE );  // 豸ѾƳ
	}
	if ( mDeviceExtension -> mPowerState == PowerDeviceD3 ) {  // ˯߻δʼ
		return( mDeviceExtension -> mDeviceGone ? FALSE : TRUE );
	}
	if ( InterlockedIncrement( & mDeviceExtension -> mOnDevExist ) != 1 ) {
		if ( mDeviceExtension -> mOnDevExist != 1 ) {
			mDelay20mS( );
			if ( mDeviceExtension -> mOnDevExist != 1 ) {
				mDelay20mS( );
				if ( mDeviceExtension -> mOnDevExist != 1 ) {
					InterlockedDecrement( & mDeviceExtension -> mOnDevExist );
					if ( mDeviceExtension -> mDeviceGone ) return( FALSE );
					return( TRUE );
				}
			}
		}
	}
	KeInitializeEvent( &mEvent, NotificationEvent, FALSE );  // ʼIRP¼źΪЧ
	for ( mPortStatus = 0; mPortStatus < 5; mPortStatus ++ ) {
		mIrp = IoBuildDeviceIoControlRequest( IOCTL_INTERNAL_USB_GET_PORT_STATUS,  // IRPѯ˿״̬
											  mDeviceExtension -> mExtNextLowerDevice,
											  NULL, 0, NULL, 0, TRUE, &mEvent, &mIoStatusBlock );
		if ( mIrp ) break;
		mDelay20mS( );
		mDelay20mS( );
	}
	if ( mIrp == NULL ) {
		InterlockedDecrement( & mDeviceExtension -> mOnDevExist );
		return( FALSE );
	}
	mPortStatus = 0;
	IoGetNextIrpStackLocation( mIrp ) -> Parameters.Others.Argument1 = &mPortStatus;  // ݸ¼豸
	mStatus = IoCallDriver( mDeviceExtension -> mExtNextLowerDevice, mIrp );  // ¼豸IO
	if ( mStatus == STATUS_PENDING ) {  // ȴҵIO
		KeWaitForSingleObject( &mEvent, Executive, KernelMode, FALSE, NULL );  // ȴIRP
		mStatus = mIoStatusBlock.Status;  // ȡ״̬
	}
	InterlockedDecrement( & mDeviceExtension -> mOnDevExist );
	if ( mStatus == STATUS_NO_SUCH_DEVICE || mStatus == STATUS_DEVICE_DOES_NOT_EXIST
		|| mStatus == STATUS_DEVICE_NOT_CONNECTED
		|| mStatus == STATUS_NO_SUCH_FILE || mStatus == STATUS_DEVICE_OFF_LINE
		|| mStatus == STATUS_UNSUCCESSFUL ) {  // 豸
			mDeviceExtension -> mDeviceGone = TRUE;  // 豸ѾƳ
			return( FALSE );
	}
	if ( mStatus == STATUS_END_OF_FILE || mStatus == STATUS_DEVICE_NOT_READY
		|| mStatus == STATUS_INVALID_DEVICE_REQUEST || mStatus == STATUS_INVALID_DEVICE_STATE
		|| mStatus == STATUS_IO_TIMEOUT || mStatus == STATUS_TIMEOUT ) {  // 豸
			return( FALSE );
	}
	if ( mStatus == STATUS_SUCCESS ) {
		if ( ( mPortStatus & USBD_PORT_CONNECTED ) == 0 ) mDeviceExtension -> mDeviceGone = TRUE;  // 豸ѾƳ
	}
	return( mPortStatus & USBD_PORT_CONNECTED ? TRUE : FALSE );  // ״̬
}

VOID		mAbortAsyncRead(
	PDEVICE_OBJECT	iDeviceObject )
{
	mPLINK_URB_BUF		mWait;
	LARGE_INTEGER		mTime;
	mPDEVICE_EXTENSION	mDeviceExtension = iDeviceObject -> DeviceExtension;  // 豸չ
	while ( mWait = mDeviceExtension -> ThreadQueueWait ) {
		mDeviceExtension -> ThreadQueueWait = mWait -> mNext;
		if ( mWait -> mStatus == STATUS_PENDING ) {  // ȴҵIO
			while ( 1 ) {
				mTime.QuadPart = 0 - 10000;
				mWait -> mStatus = KeWaitForSingleObject( & mWait -> mEvent, Executive, KernelMode, FALSE, &mTime );  // ȴIRP
				if ( mWait -> mStatus != STATUS_TIMEOUT ) break;
				mRequestPipe( iDeviceObject, URB_FUNCTION_ABORT_PIPE, mPipeDataUp );  // ȡ
			}
		}
		InterlockedDecrement( & mDeviceExtension -> ThreadUsbCount );
	}
}

VOID		mThreadRead(  // ϵͳ߳
	PVOID	iContext )
{
	PUCHAR				mBuffer;
	KIRQL				mOldIrql;
	ULONG				i, mLength;
	PIRP				mIrp;
	PDEVICE_OBJECT		mDeviceObject;
	mPDEVICE_EXTENSION	mDeviceExtension;
	NTSTATUS			mStatus;
	mPLINK_URB_BUF		mFree, mWait;
	mDeviceObject = (PDEVICE_OBJECT)iContext;  // 豸
	mDeviceExtension = mDeviceObject -> DeviceExtension;  // 豸չ
	InterlockedIncrement( & mDeviceExtension -> mThreadCount );
	KeSetPriorityThread( KeGetCurrentThread(), LOW_REALTIME_PRIORITY + 1 );  // 趨ǰ߳Ϊʵʱȼ
	mLength = 131072;
	mBuffer = ExAllocatePool( NonPagedPool, mLength );
	if ( mBuffer == NULL ) PsTerminateSystemThread( STATUS_INSUFFICIENT_RESOURCES );  // ֹϵͳ߳
	mDeviceExtension -> ThreadInSize = 0;
	mLength = ( mLength - sizeof( mLINK_URB_BUF ) * mTHREAD_MAX_LINK ) / ( mCH375_PACKET_LENGTH + 1 );
	mDeviceExtension -> ThreadBufSize = mLength * ( mCH375_PACKET_LENGTH + 1 );
	mDeviceExtension -> ThreadInStart = mDeviceExtension -> ThreadOutStart = mBuffer;
	mDeviceExtension -> ThreadQueueWait = mDeviceExtension -> ThreadQueueFree = NULL;
	mDeviceExtension -> ThreadBuffer = mBuffer;
	mWait = (PVOID)( mDeviceExtension -> ThreadBuffer + mDeviceExtension -> ThreadBufSize );
	for ( mLength = 0; mLength < mTHREAD_MAX_LINK; mLength ++ ) {
		mWait -> mNext = mDeviceExtension -> ThreadQueueFree;
		KeInitializeEvent( & mWait -> mEvent, NotificationEvent, FALSE );  // ʼIRP¼źΪЧ
		mDeviceExtension -> ThreadQueueFree = mWait;
		mWait ++;
	}
	mDeviceExtension -> ThreadUsbCount = 0;
	while ( mDriverObject != NULL && mDeviceExtension -> mExtDeviceRemove == FALSE && mDeviceExtension -> ThreadBufSize != 0 ) {  // ϵͳδж,豸δƳ
//		InterlockedIncrement( & mDeviceExtension -> mExtIoCount );  // ,ֹ;ֹͣƳ豸
		KeWaitForSingleObject( & mDeviceExtension -> ThreadStartEvent, Executive, KernelMode, FALSE, NULL );
		while ( mDriverObject != NULL && mDeviceExtension -> mPowerState == PowerDeviceD0  // ϵͳδж,豸δƳ
				&& mDeviceExtension -> mExtDeviceStart != FALSE && mDeviceExtension -> mExtDeviceRemove == FALSE ) {  // 豸ѾδƳ
			if ( mDeviceExtension -> ThreadBufSize == 0 ) break;  // ǿ˳
			while ( mFree = mDeviceExtension -> ThreadQueueFree ) {
				mDeviceExtension -> ThreadQueueFree = mFree -> mNext;
				mFree -> mNext = NULL;
				if ( mWait = mDeviceExtension -> ThreadQueueWait ) {
					while ( mWait -> mNext ) mWait = mWait -> mNext;
					mWait -> mNext = mFree;
				}
				else mDeviceExtension -> ThreadQueueWait = mFree;
				InterlockedIncrement( & mDeviceExtension -> ThreadUsbCount );  // 
				UsbBuildInterruptOrBulkTransferRequest( & mFree -> mUrb, sizeof( struct _URB_BULK_OR_INTERRUPT_TRANSFER ),  // USB
														mDeviceExtension -> mExtDataUpPipe, mFree -> mBuffer, NULL, mCH375_PACKET_LENGTH,  // ܵľ
														USBD_TRANSFER_DIRECTION_IN | USBD_SHORT_TRANSFER_OK, NULL );  // ־
				KeClearEvent( & mFree -> mEvent );  // IRP¼źΪЧ
				mIrp = IoBuildDeviceIoControlRequest( IOCTL_INTERNAL_USB_SUBMIT_URB, mDeviceExtension -> mExtNextLowerDevice,
													  NULL, 0, NULL, 0, TRUE, & mFree -> mEvent, & mFree -> mIoStatusBlock );  // IRPύURB
				if ( mIrp != NULL ) {  // IRPЧ
					IoGetNextIrpStackLocation( mIrp ) -> Parameters.Others.Argument1 = & mFree -> mUrb;  // URBΪݸ¼豸
					mFree -> mStatus = IoCallDriver( mDeviceExtension -> mExtNextLowerDevice, mIrp );  // ¼豸IO
				}
				else mFree -> mStatus = STATUS_INSUFFICIENT_RESOURCES;  // ʧ
			}
			mWait = mDeviceExtension -> ThreadQueueWait;
			if ( mWait == NULL ) break;
			mDeviceExtension -> ThreadQueueWait = mWait -> mNext;
			mWait -> mNext = mDeviceExtension -> ThreadQueueFree;
			mDeviceExtension -> ThreadQueueFree = mWait;
			if ( mWait -> mStatus == STATUS_PENDING ) {  // ȴҵIO
				KeWaitForSingleObject( & mWait -> mEvent, Executive, KernelMode, FALSE, NULL );  // ȴIRP
				mWait -> mStatus = mWait -> mIoStatusBlock.Status;  // ȡ״̬
			}
			InterlockedDecrement( & mDeviceExtension -> ThreadUsbCount );
			if ( mDeviceExtension -> ThreadBufSize == 0 ) break;  // ǿ˳
			mStatus = mWait -> mStatus;
			mLength = mWait -> mUrb.UrbBulkOrInterruptTransfer.TransferBufferLength;  // ʵʴ䳤
			if ( NT_SUCCESS( mStatus ) && ( mLength || mWait -> mUrb.UrbBulkOrInterruptTransfer.Hdr.Status != USBD_STATUS_CANCELED ) ) {
				KeAcquireSpinLock( & mDeviceExtension -> mControlLock, &mOldIrql );
				if ( mDeviceExtension -> ThreadBuffer ) {
					if ( mDeviceExtension -> ThreadInStart >= mDeviceExtension -> ThreadBuffer + mDeviceExtension -> ThreadBufSize )
						mDeviceExtension -> ThreadInStart = mDeviceExtension -> ThreadBuffer;
					*( mDeviceExtension -> ThreadInStart ) = (UCHAR)mLength;
					RtlCopyMemory( mDeviceExtension -> ThreadInStart + 1, mWait -> mBuffer, mLength );
					mDeviceExtension -> ThreadInStart += mCH375_PACKET_LENGTH + 1;
					mDeviceExtension -> ThreadInSize += mCH375_PACKET_LENGTH + 1;
					if ( mDeviceExtension -> ThreadInSize > mDeviceExtension -> ThreadBufSize ) {  // 
						mDeviceExtension -> ThreadInSize = mDeviceExtension -> ThreadBufSize;
						mDeviceExtension -> ThreadOutStart = mDeviceExtension -> ThreadInStart;
					}
				}
				KeReleaseSpinLock( & mDeviceExtension -> mControlLock, mOldIrql );
			}
			else if ( ! NT_SUCCESS( mStatus ) ) {
				if ( mIsDeviceExist( mDeviceObject, mStatus ) == FALSE ) break;  // 豸ѾƳ
				if ( mDeviceExtension -> mExtDeviceRemove == FALSE )  // 豸δƳ
					mRequestPipe( mDeviceObject, URB_FUNCTION_RESET_PIPE, mPipeDataUp );  // λܵ
			}
		}
		mAbortAsyncRead( mDeviceObject );
//		InterlockedDecrement( & mDeviceExtension -> mExtIoCount );
		if ( mIsDeviceExist( mDeviceObject, STATUS_SUCCESS ) == FALSE ) break;  // 豸ѾƳ
	}
	mAbortAsyncRead( mDeviceObject );
	ExFreePool( mDeviceExtension -> ThreadBuffer );  // ͷڴ
	mDeviceExtension -> ThreadBuffer = NULL;
	InterlockedDecrement( & mDeviceExtension -> mThreadCount );
	PsTerminateSystemThread( STATUS_SUCCESS );  // ֹϵͳ߳
}

NTSTATUS	mExitThreadRead(
	PDEVICE_OBJECT	iDeviceObject )
{
	ULONG				i;
	mPDEVICE_EXTENSION	mDeviceExtension;
	mDeviceExtension = iDeviceObject -> DeviceExtension;  // 豸չ
	for ( i = 0; i < 50; i ++ ) {
		mDeviceExtension -> ThreadBufSize = 0;  // ǿ˳
		KeSetEvent( & mDeviceExtension -> ThreadStartEvent, IO_CH375_INCREMENT, FALSE );  // ߳¼
		if ( mDeviceExtension -> ThreadBuffer == NULL ) break;
		mDelay20mS( );
		if ( mDeviceExtension -> ThreadBuffer == NULL ) break;
		mRequestPipe( iDeviceObject, (USHORT)( i > 30 ? URB_FUNCTION_RESET_PIPE : URB_FUNCTION_ABORT_PIPE ), mPipeDataUp );  // ȡ
	}
	return( i >= 50 ? STATUS_UNSUCCESSFUL : STATUS_SUCCESS );
}

NTSTATUS	mGetBufferData(
	PDEVICE_OBJECT	iDeviceObject,
	PUCHAR			oBuffer,
	PULONG			ioLength )  // Ϊ󳤶,Ϊʵʷس
{
	ULONG				mReqLen, mPktSize;
	KIRQL				mOldIrql;
	mPDEVICE_EXTENSION	mDeviceExtension;
	mDeviceExtension = iDeviceObject -> DeviceExtension;  // 豸չ
	mReqLen = *ioLength;
	*ioLength = 0;
	if ( mDeviceExtension -> mExtDeviceRemove ) return( STATUS_CANCELLED );
	if ( mReqLen && mDeviceExtension -> ThreadInSize ) {
		KeAcquireSpinLock( & mDeviceExtension -> mControlLock, &mOldIrql );
		while ( mReqLen && mDeviceExtension -> ThreadInSize && mDeviceExtension -> ThreadBuffer ) {
			if ( mDeviceExtension -> ThreadOutStart >= mDeviceExtension -> ThreadBuffer + mDeviceExtension -> ThreadBufSize )
				mDeviceExtension -> ThreadOutStart = mDeviceExtension -> ThreadBuffer;
			mPktSize = *( mDeviceExtension -> ThreadOutStart );
			if ( mPktSize > mReqLen ) {
				if ( mPktSize > mCH375_PACKET_LENGTH ) mReqLen = 0;
				mPktSize = mReqLen;
			}
			RtlCopyMemory( oBuffer, mDeviceExtension -> ThreadOutStart + 1, mPktSize );
			mDeviceExtension -> ThreadOutStart += mCH375_PACKET_LENGTH + 1;
			mDeviceExtension -> ThreadInSize -= mCH375_PACKET_LENGTH + 1;
			oBuffer += mPktSize;
			mReqLen -= mPktSize;
			*ioLength += mPktSize;
		}
		KeReleaseSpinLock( & mDeviceExtension -> mControlLock, mOldIrql );
	}
	return( STATUS_SUCCESS );
}

VOID		mClearUpBufferData(
	PDEVICE_OBJECT	iDeviceObject )
{
	KIRQL				mOldIrql;
	mPDEVICE_EXTENSION	mDeviceExtension;
	mDeviceExtension = iDeviceObject -> DeviceExtension;  // 豸չ
	KeAcquireSpinLock( & mDeviceExtension -> mControlLock, &mOldIrql );
	if ( mDeviceExtension -> ThreadBuffer ) {
		if ( mDeviceExtension -> ThreadInStart >= mDeviceExtension -> ThreadBuffer + mDeviceExtension -> ThreadBufSize )
			mDeviceExtension -> ThreadInStart = mDeviceExtension -> ThreadBuffer;
		mDeviceExtension -> ThreadOutStart = mDeviceExtension -> ThreadInStart;
		mDeviceExtension -> ThreadInSize = 0;
	}
	KeReleaseSpinLock( & mDeviceExtension -> mControlLock, mOldIrql );
}

VOID		mAbortAsyncWrite(
	PDEVICE_OBJECT	iDeviceObject )
{
	mPLINK_URB_BUF		mWait;
	LARGE_INTEGER		mTime;
	mPDEVICE_EXTENSION	mDeviceExtension = iDeviceObject -> DeviceExtension;  // 豸չ
	while ( mWait = mDeviceExtension -> DnThreadQueueWait ) {
		mDeviceExtension -> DnThreadQueueWait = mWait -> mNext;
		if ( mWait -> mStatus == STATUS_PENDING ) {  // ȴҵIO
			while ( 1 ) {
				mTime.QuadPart = 0 - 10000;
				mWait -> mStatus = KeWaitForSingleObject( & mWait -> mEvent, Executive, KernelMode, FALSE, &mTime );  // ȴIRP
				if ( mWait -> mStatus != STATUS_TIMEOUT ) break;
				mRequestPipe( iDeviceObject, URB_FUNCTION_ABORT_PIPE, mPipeDataDown );  // ȡ
			}
		}
		InterlockedDecrement( & mDeviceExtension -> DnThreadUsbCount );
	}
}

VOID		mThreadWrite(  // ϵͳ߳
	PVOID	iContext )
{
	PUCHAR				mBuffer;
	KIRQL				mOldIrql;
	ULONG				i, mLength;
	PIRP				mIrp;
	PDEVICE_OBJECT		mDeviceObject;
	mPDEVICE_EXTENSION	mDeviceExtension;
	NTSTATUS			mStatus;
	mPLINK_URB_BUF		mFree, mWait;
	mDeviceObject = (PDEVICE_OBJECT)iContext;  // 豸
	mDeviceExtension = mDeviceObject -> DeviceExtension;  // 豸չ
	InterlockedIncrement( & mDeviceExtension -> mThreadCount );
	KeSetPriorityThread( KeGetCurrentThread(), LOW_REALTIME_PRIORITY );  // 趨ǰ߳Ϊʵʱȼ
	mLength = 131072;
	mBuffer = ExAllocatePool( NonPagedPool, mLength );
	if ( mBuffer == NULL ) PsTerminateSystemThread( STATUS_INSUFFICIENT_RESOURCES );  // ֹϵͳ߳
	mDeviceExtension -> DnThreadInSize = 0;
	mLength = ( mLength - sizeof( mLINK_URB_BUF ) * mTHREAD_MAX_LINK ) / ( mCH375_PACKET_LENGTH + 1 );
	mDeviceExtension -> DnThreadBufSize = mLength * ( mCH375_PACKET_LENGTH + 1 );
	mDeviceExtension -> DnThreadInStart = mDeviceExtension -> DnThreadOutStart = mBuffer;
	mDeviceExtension -> DnThreadQueueWait = mDeviceExtension -> DnThreadQueueFree = NULL;
	mDeviceExtension -> DnThreadBuffer = mBuffer;
	mWait = (PVOID)( mDeviceExtension -> DnThreadBuffer + mDeviceExtension -> DnThreadBufSize );
	for ( mLength = 0; mLength < mTHREAD_MAX_LINK; mLength ++ ) {
		mWait -> mNext = mDeviceExtension -> DnThreadQueueFree;
		KeInitializeEvent( & mWait -> mEvent, NotificationEvent, FALSE );  // ʼIRP¼źΪЧ
		mDeviceExtension -> DnThreadQueueFree = mWait;
		mWait ++;
	}
	mDeviceExtension -> DnThreadUsbCount = 0;
	while ( mDriverObject != NULL && mDeviceExtension -> mExtDeviceRemove == FALSE && mDeviceExtension -> DnThreadBufSize != 0 ) {  // ϵͳδж,豸δƳ
//		InterlockedIncrement( & mDeviceExtension -> mExtIoCount );  // ,ֹ;ֹͣƳ豸
ThreadWriteWait:
		if ( mDeviceExtension -> mExtDeviceStart == FALSE ) mAbortAsyncWrite( mDeviceObject );
		KeWaitForSingleObject( & mDeviceExtension -> DnThreadStartEvent, Executive, KernelMode, FALSE, NULL );
		while ( mDriverObject != NULL && mDeviceExtension -> mPowerState == PowerDeviceD0  // ϵͳδж,豸δƳ
				&& mDeviceExtension -> mExtDeviceStart != FALSE && mDeviceExtension -> mExtDeviceRemove == FALSE ) {  // 豸ѾδƳ
			if ( mDeviceExtension -> DnThreadBufSize == 0 ) break;  // ǿ˳
			while ( mDeviceExtension -> DnThreadInSize && mDeviceExtension -> DnThreadQueueFree ) {
				mFree = NULL;
				KeAcquireSpinLock( & mDeviceExtension -> mControlLockDn, &mOldIrql );
				if ( mDeviceExtension -> DnThreadInSize && mDeviceExtension -> DnThreadBuffer ) {
					if ( mDeviceExtension -> DnThreadOutStart >= mDeviceExtension -> DnThreadBuffer + mDeviceExtension -> DnThreadBufSize )
						mDeviceExtension -> DnThreadOutStart = mDeviceExtension -> DnThreadBuffer;
					if ( mFree = mDeviceExtension -> DnThreadQueueFree ) {
						mDeviceExtension -> DnThreadQueueFree = mFree -> mNext;
						mFree -> mNext = NULL;
						mLength = *( mDeviceExtension -> DnThreadOutStart );
						RtlCopyMemory( mFree -> mBuffer, mDeviceExtension -> DnThreadOutStart + 1, mLength );
						mDeviceExtension -> DnThreadOutStart += mCH375_PACKET_LENGTH + 1;
						mDeviceExtension -> DnThreadInSize -= mCH375_PACKET_LENGTH + 1;
						if ( mWait = mDeviceExtension -> DnThreadQueueWait ) {
							while ( mWait -> mNext ) mWait = mWait -> mNext;
							mWait -> mNext = mFree;
						}
						else mDeviceExtension -> DnThreadQueueWait = mFree;
					}
				}
				KeReleaseSpinLock( & mDeviceExtension -> mControlLockDn, mOldIrql );
				if ( mFree ) {						
					InterlockedIncrement( & mDeviceExtension -> DnThreadUsbCount );  // 
					UsbBuildInterruptOrBulkTransferRequest( & mFree -> mUrb, sizeof( struct _URB_BULK_OR_INTERRUPT_TRANSFER ),  // USB
															mDeviceExtension -> mExtDataDownPipe, mFree -> mBuffer, NULL, mLength,  // ܵľ
															USBD_TRANSFER_DIRECTION_OUT | USBD_SHORT_TRANSFER_OK, NULL );  // ־
					KeClearEvent( & mFree -> mEvent );  // IRP¼źΪЧ
					mIrp = IoBuildDeviceIoControlRequest( IOCTL_INTERNAL_USB_SUBMIT_URB, mDeviceExtension -> mExtNextLowerDevice,
														  NULL, 0, NULL, 0, TRUE, & mFree -> mEvent, & mFree -> mIoStatusBlock );  // IRPύURB
					if ( mIrp != NULL ) {  // IRPЧ
						IoGetNextIrpStackLocation( mIrp ) -> Parameters.Others.Argument1 = & mFree -> mUrb;  // URBΪݸ¼豸
						mFree -> mStatus = IoCallDriver( mDeviceExtension -> mExtNextLowerDevice, mIrp );  // ¼豸IO
					}
					else mFree -> mStatus = STATUS_INSUFFICIENT_RESOURCES;  // ʧ
				}
				else break;
			}
			mWait = mDeviceExtension -> DnThreadQueueWait;
			if ( mWait == NULL ) goto ThreadWriteWait;
			mDeviceExtension -> DnThreadQueueWait = mWait -> mNext;
			mWait -> mNext = mDeviceExtension -> DnThreadQueueFree;
			mDeviceExtension -> DnThreadQueueFree = mWait;
			if ( mWait -> mStatus == STATUS_PENDING ) {  // ȴҵIO
				KeWaitForSingleObject( & mWait -> mEvent, Executive, KernelMode, FALSE, NULL );  // ȴIRP
				mWait -> mStatus = mWait -> mIoStatusBlock.Status;  // ȡ״̬
			}
			InterlockedDecrement( & mDeviceExtension -> DnThreadUsbCount );
			if ( mDeviceExtension -> DnThreadBufSize == 0 ) break;  // ǿ˳
			mStatus = mWait -> mStatus;
			if ( ! NT_SUCCESS( mStatus ) ) {
				if ( mIsDeviceExist( mDeviceObject, mStatus ) == FALSE ) break;  // 豸ѾƳ
				if ( mDeviceExtension -> mExtDeviceRemove == FALSE )  // 豸δƳ
					mRequestPipe( mDeviceObject, URB_FUNCTION_RESET_PIPE, mPipeDataDown );  // λܵ
			}
		}
		mAbortAsyncWrite( mDeviceObject );
//		InterlockedDecrement( & mDeviceExtension -> mExtIoCount );
		if ( mIsDeviceExist( mDeviceObject, STATUS_SUCCESS ) == FALSE ) break;  // 豸ѾƳ
	}
	mAbortAsyncWrite( mDeviceObject );
	ExFreePool( mDeviceExtension -> DnThreadBuffer );  // ͷڴ
	mDeviceExtension -> DnThreadBuffer = NULL;
	InterlockedDecrement( & mDeviceExtension -> mThreadCount );
	PsTerminateSystemThread( STATUS_SUCCESS );  // ֹϵͳ߳
}

NTSTATUS	mExitThreadWrite(
	PDEVICE_OBJECT	iDeviceObject )
{
	ULONG				i;
	mPDEVICE_EXTENSION	mDeviceExtension;
	mDeviceExtension = iDeviceObject -> DeviceExtension;  // 豸չ
	for ( i = 0; i < 50; i ++ ) {
		mDeviceExtension -> DnThreadBufSize = 0;  // ǿ˳
		KeSetEvent( & mDeviceExtension -> DnThreadStartEvent, IO_CH375_INCREMENT, FALSE );  // ߳¼
		if ( mDeviceExtension -> DnThreadBuffer == NULL ) break;
		mDelay20mS( );
		if ( mDeviceExtension -> DnThreadBuffer == NULL ) break;
		mRequestPipe( iDeviceObject, (USHORT)( i > 30 ? URB_FUNCTION_RESET_PIPE : URB_FUNCTION_ABORT_PIPE ), mPipeDataDown );  // ȡ
	}
	return( i >= 50 ? STATUS_UNSUCCESSFUL : STATUS_SUCCESS );
}

NTSTATUS	mPutBufferData(
	PDEVICE_OBJECT	iDeviceObject,
	PUCHAR			iBuffer,
	ULONG			iLength )  // Ϊ󳤶
{
	ULONG				mReqLen, mPktSize;
	KIRQL				mOldIrql;
	mPDEVICE_EXTENSION	mDeviceExtension;
	mDeviceExtension = iDeviceObject -> DeviceExtension;  // 豸չ
	if ( mDeviceExtension -> mExtDeviceRemove ) return( STATUS_CANCELLED );
	mReqLen = ( iLength + mCH375_PACKET_LENGTH - 1 ) / mCH375_PACKET_LENGTH;
	mReqLen *= mCH375_PACKET_LENGTH + 1;
	if ( mDeviceExtension -> DnThreadInSize + mReqLen > mDeviceExtension -> DnThreadBufSize ) {
		KeSetEvent( & mDeviceExtension -> DnThreadStartEvent, IO_CH375_INCREMENT, FALSE );  // ߳¼
		return( STATUS_BUFFER_OVERFLOW );  // 
	}
	if ( mReqLen ) {
		KeAcquireSpinLock( & mDeviceExtension -> mControlLockDn, &mOldIrql );
		if ( mDeviceExtension -> DnThreadBuffer ) {
			while ( mReqLen ) {
				if ( mDeviceExtension -> DnThreadInStart >= mDeviceExtension -> DnThreadBuffer + mDeviceExtension -> DnThreadBufSize )
					mDeviceExtension -> DnThreadInStart = mDeviceExtension -> DnThreadBuffer;
				if ( mReqLen > mCH375_PACKET_LENGTH + 1 ) mPktSize = mCH375_PACKET_LENGTH;
				else {
					mPktSize = iLength & ( mCH375_PACKET_LENGTH - 1 );
					if ( mPktSize == 0 ) mPktSize = mCH375_PACKET_LENGTH;
				}
				*( mDeviceExtension -> DnThreadInStart ) = (UCHAR)mPktSize;
				RtlCopyMemory( mDeviceExtension -> DnThreadInStart + 1, iBuffer, mPktSize );
				mDeviceExtension -> DnThreadInStart += mCH375_PACKET_LENGTH + 1;
				mDeviceExtension -> DnThreadInSize += mCH375_PACKET_LENGTH + 1;
				if ( mDeviceExtension -> DnThreadInSize > mDeviceExtension -> DnThreadBufSize ) {  // 
					mDeviceExtension -> DnThreadInSize = mDeviceExtension -> DnThreadBufSize;
					mDeviceExtension -> DnThreadOutStart = mDeviceExtension -> DnThreadInStart;
				}
				iBuffer += mPktSize;
				mReqLen -= mCH375_PACKET_LENGTH + 1;
			}
		}
		KeReleaseSpinLock( & mDeviceExtension -> mControlLockDn, mOldIrql );
	}
	KeSetEvent( & mDeviceExtension -> DnThreadStartEvent, IO_CH375_INCREMENT, FALSE );  // ߳¼
	return( STATUS_SUCCESS );
}

VOID		mClearDnBufferData(
	PDEVICE_OBJECT	iDeviceObject )
{
	KIRQL				mOldIrql;
	mPDEVICE_EXTENSION	mDeviceExtension;
	mDeviceExtension = iDeviceObject -> DeviceExtension;  // 豸չ
	KeAcquireSpinLock( & mDeviceExtension -> mControlLockDn, &mOldIrql );
	if ( mDeviceExtension -> DnThreadBuffer ) {
		if ( mDeviceExtension -> DnThreadInStart >= mDeviceExtension -> DnThreadBuffer + mDeviceExtension -> DnThreadBufSize )
			mDeviceExtension -> DnThreadInStart = mDeviceExtension -> DnThreadBuffer;
		mDeviceExtension -> DnThreadOutStart = mDeviceExtension -> DnThreadInStart;
		mDeviceExtension -> DnThreadInSize = 0;
	}
	KeReleaseSpinLock( & mDeviceExtension -> mControlLockDn, mOldIrql );
}

NTSTATUS	mResetUsbDevice(
	PDEVICE_OBJECT	iDeviceObject )
{
	PIRP				mIrp;
	KEVENT				mEvent;
	IO_STATUS_BLOCK		mIoStatusBlock;
	NTSTATUS			mStatus;
	mPDEVICE_EXTENSION	mDeviceExtension;
	mDeviceExtension = iDeviceObject -> DeviceExtension;  // 豸չ
	InterlockedDecrement( & mDeviceExtension -> mExtIoCount );  // ,ԱڹرջƳ豸
	KeInitializeEvent( &mEvent, NotificationEvent, FALSE );  // ʼIRP¼źΪЧ
	mIrp = IoBuildDeviceIoControlRequest( IOCTL_INTERNAL_USB_RESET_PORT,  // IRPλ˿
										  mDeviceExtension -> mExtNextLowerDevice,
										  NULL, 0, NULL, 0, TRUE, &mEvent, &mIoStatusBlock );
	mStatus = IoCallDriver( mDeviceExtension -> mExtNextLowerDevice, mIrp );  // ¼豸IO,λ˿
	if ( mStatus == STATUS_PENDING ) {  // ȴҵIO
		KeWaitForSingleObject( &mEvent, Executive, KernelMode, FALSE, NULL );  // ȴIRP
		mStatus = mIoStatusBlock.Status;  // ȡ״̬
	}
	InterlockedIncrement( & mDeviceExtension -> mExtIoCount );  // 
	return( mStatus );
}

VOID		mThreadTimeout(  // ϵͳ߳
	PVOID	iContext )
{
	PDEVICE_OBJECT		mDeviceObject;
	mPDEVICE_EXTENSION	mDeviceExtension;
	LARGE_INTEGER		mWaitTime, mReqTime, mCurrentTime;
	mDeviceObject = (PDEVICE_OBJECT)iContext;  // 豸
	mDeviceExtension = mDeviceObject -> DeviceExtension;  // 豸չ
	InterlockedIncrement( & mDeviceExtension -> mThreadCount );
	KeSetPriorityThread( KeGetCurrentThread(), LOW_REALTIME_PRIORITY );  // 趨ǰ߳Ϊʵʱȼ
	while ( mDriverObject != NULL && mDeviceExtension -> mExtDeviceRemove == FALSE ) {  // ϵͳδж,豸δƳ
		mWaitTime.QuadPart = 10000000;  // 1S
		KeQuerySystemTime( & mCurrentTime );
		if ( mDeviceExtension -> mExtDownTimeout < 0x80000000 && mDeviceExtension -> mExtDownStartTime.QuadPart ) {  // Ҫ鳬ʱ
			mReqTime.QuadPart = mDeviceExtension -> mExtDownStartTime.QuadPart + mDeviceExtension -> mExtDownWaitTime.QuadPart - mCurrentTime.QuadPart;
			if ( mReqTime.QuadPart < mWaitTime.QuadPart ) mWaitTime.QuadPart = mReqTime.QuadPart;
		}
		if ( mDeviceExtension -> mExtUpTimeout < 0x80000000 && mDeviceExtension -> mExtUpStartTime.QuadPart ) {  // Ҫ鳬ʱ
			mReqTime.QuadPart = mDeviceExtension -> mExtUpStartTime.QuadPart + mDeviceExtension -> mExtUpWaitTime.QuadPart - mCurrentTime.QuadPart;
			if ( mReqTime.QuadPart < mWaitTime.QuadPart ) mWaitTime.QuadPart = mReqTime.QuadPart;
		}
		if ( mDeviceExtension -> mExtAuxTimeout < 0x80000000 && mDeviceExtension -> mExtAuxStartTime.QuadPart ) {  // Ҫ鳬ʱ
			mReqTime.QuadPart = mDeviceExtension -> mExtAuxStartTime.QuadPart + mDeviceExtension -> mExtAuxWaitTime.QuadPart - mCurrentTime.QuadPart;
			if ( mReqTime.QuadPart < mWaitTime.QuadPart ) mWaitTime.QuadPart = mReqTime.QuadPart;
		}
		if ( mDeviceExtension -> mExtInterTimeout < 0x80000000 && mDeviceExtension -> mExtInterStartTime.QuadPart ) {  // Ҫ鳬ʱ
			mReqTime.QuadPart = mDeviceExtension -> mExtInterStartTime.QuadPart + mDeviceExtension -> mExtInterWaitTime.QuadPart - mCurrentTime.QuadPart;
			if ( mReqTime.QuadPart < mWaitTime.QuadPart ) mWaitTime.QuadPart = mReqTime.QuadPart;
		}
		mWaitTime.QuadPart = 0 - mWaitTime.QuadPart;
		KeWaitForSingleObject( & mDeviceExtension -> mExtThreadToutEvent, Executive, KernelMode, FALSE, &mWaitTime );
		if ( mDeviceExtension -> mExtDeviceOpen == 0 ) IoSetDeviceInterfaceState( & mDeviceExtension -> mExtDeviceName, TRUE );  // 豸ӿ
		KeQuerySystemTime( & mCurrentTime );
		if ( mDeviceExtension -> mExtUsbDownCount ) {
			if ( mDeviceExtension -> mExtDownStartTime.u.HighPart == 0x87654321 ||  // ȡ
				mDeviceExtension -> mExtDownTimeout < 0x80000000 && mDeviceExtension -> mExtDownStartTime.QuadPart &&  // Ҫ鳬ʱ
				mDeviceExtension -> mExtDownStartTime.QuadPart + mDeviceExtension -> mExtDownWaitTime.QuadPart <= mCurrentTime.QuadPart ) {
				mDeviceExtension -> mExtDownStartTime.QuadPart = 0;
				mRequestPipe( mDeviceObject, URB_FUNCTION_ABORT_PIPE, mPipeDataDown );  // ִָܵȡ
			}
		}
		if ( mDeviceExtension -> mExtUsbUpCount ) {
			if ( mDeviceExtension -> mExtUpStartTime.u.HighPart == 0x87654321 ||  // ȡ
				mDeviceExtension -> mExtUpTimeout < 0x80000000 && mDeviceExtension -> mExtUpStartTime.QuadPart &&  // Ҫ鳬ʱ
				mDeviceExtension -> mExtUpStartTime.QuadPart + mDeviceExtension -> mExtUpWaitTime.QuadPart <= mCurrentTime.QuadPart ) {
				mDeviceExtension -> mExtUpStartTime.QuadPart = 0;
				mRequestPipe( mDeviceObject, URB_FUNCTION_ABORT_PIPE, mPipeDataUp );  // ִָܵȡ
			}
		}
		if ( mDeviceExtension -> mExtUsbAuxCount ) {
			if ( mDeviceExtension -> mExtAuxStartTime.u.HighPart == 0x87654321 ||  // ȡ
				mDeviceExtension -> mExtAuxTimeout < 0x80000000 && mDeviceExtension -> mExtAuxStartTime.QuadPart &&  // Ҫ鳬ʱ
				mDeviceExtension -> mExtAuxStartTime.QuadPart + mDeviceExtension -> mExtAuxWaitTime.QuadPart <= mCurrentTime.QuadPart ) {
				mDeviceExtension -> mExtAuxStartTime.QuadPart = 0;
				mRequestPipe( mDeviceObject, URB_FUNCTION_ABORT_PIPE, mPipeAuxDown );  // ִָܵȡ
			}
		}
		if ( mDeviceExtension -> mExtUsbInterCount ) {
			if ( mDeviceExtension -> mExtInterStartTime.u.HighPart == 0x87654321 ||  // ȡ
				mDeviceExtension -> mExtInterTimeout < 0x80000000 && mDeviceExtension -> mExtInterStartTime.QuadPart &&  // Ҫ鳬ʱ
				mDeviceExtension -> mExtInterStartTime.QuadPart + mDeviceExtension -> mExtInterWaitTime.QuadPart <= mCurrentTime.QuadPart ) {
				mDeviceExtension -> mExtInterStartTime.QuadPart = 0;
				mRequestPipe( mDeviceObject, URB_FUNCTION_ABORT_PIPE, mPipeInterUp );  // ִָܵȡ
			}
		}
	}
	InterlockedDecrement( & mDeviceExtension -> mThreadCount );
	PsTerminateSystemThread( STATUS_SUCCESS );  // ֹϵͳ߳
}

VOID		mDelay20mS( void )
{
	LARGE_INTEGER		mTime;
	mTime.QuadPart = 0 - 200000;
	KeDelayExecutionThread( KernelMode, FALSE, &mTime );
}


// end
