// 2003.09.08, 2003.12.28, 2004.10.15, 2004.12.05, 2004.12.10, 2005.01.20, 2005.02.23, 2005.07.15, 2005.08.17, 2005.08.23, 2005.12.15, 2009.06.05, 2011,02.22
//****************************************
//**  Copyright  (C)  W.ch  1999-2011   **
//**  Web:  http://www.winchiphead.com  **
//****************************************
//**  WDM for USB interface chip CH375  **
//**  C, VC5.0, Windows 98 DDK          **
//****************************************
//
// USB߽ӿоƬCH375WDM   V2.6
// Ͼߺ޹˾       http://wch.cn
// CH375-WDM  V2.7, Support: Ctrl/Bulk/Int
// л: Windows 98/ME, Windows 2000/XP/VISTA/7/SERVER2003/SERVER2008
// support USB chip: CH372/CH375
//

#ifndef		_CH375_WDM_H
#define		_CH375_WDM_H

#ifdef		_WIN64
#define		mOFFSET( s, m )			( (ULONG_PTR) & ( ( ( s * ) 0 ) -> m ) )	// ȡṹԱƫƵַĺ
#else
#define		mOFFSET( s, m )			( (ULONG) & ( ( ( s * ) 0 ) -> m ) )	// ȡṹԱƫƵַĺ
#endif

#ifndef		max
#define		max( a, b )				( ( ( a ) > ( b ) ) ? ( a ) : ( b ) )	// ϴֵ
#endif

#ifndef		min
#define		min( a, b )				( ( ( a ) < ( b ) ) ? ( a ) : ( b ) )	// Сֵ
#endif

#ifdef		ExAllocatePool
#undef		ExAllocatePool						// ɾTAGڴ
#endif

#ifndef		NTSTATUS
typedef		LONG	NTSTATUS;					// ״̬
#endif


typedef	struct	_USB_SETUP_PKT {				// USBƴĽ׶εṹ
	UCHAR			mUspReqType;				// 00H 
	UCHAR			mUspRequest;				// 01H 
	union	{
		struct	{
			UCHAR	mUspValueLow;				// 02H ֵֽ
			UCHAR	mUspValueHigh;				// 03H ֵֽ
		};
		USHORT		mUspValue;					// 02H-03H ֵ
	};
	union	{
		struct	{
			UCHAR	mUspIndexLow;				// 04H ֽ
			UCHAR	mUspIndexHigh;				// 05H ֽ
		};
		USHORT		mUspIndex;					// 04H-05H 
	};
	USHORT			mLength;					// 06H-07H ݽ׶εݳ
} mUSB_SETUP_PKT, *mPUSB_SETUP_PKT;


#define		mCH375_PACKET_LENGTH	64			// CH375ֵ֧ݰĳ


typedef	struct	_WIN32_COMMAND {				// WIN32ӿڽṹ
	union	{
		ULONG		mFunction;					// ʱָܴ߹ܵ
		NTSTATUS	mStatus;					// ʱز״̬
	};
	ULONG			mLength;					// ȡ,غݵĳ
	union	{
		mUSB_SETUP_PKT	mSetupPkt;				// USBƴĽ׶ε
		UCHAR			mBuffer[ mCH375_PACKET_LENGTH ];	// ݻ,Ϊ0255B
	};
} mWIN32_COMMAND, *mPWIN32_COMMAND;


// WIN32Ӧòӿ
#define		IOCTL_CH375_COMMAND		( FILE_DEVICE_UNKNOWN << 16 | FILE_ANY_ACCESS << 14 | 0x0f37 << 2 | METHOD_BUFFERED )	// רýӿ

#define		mWIN32_COMMAND_HEAD		mOFFSET( mWIN32_COMMAND, mBuffer )	// WIN32ӿڵͷ

#define		mCH375_MAX_NUMBER		16			// ͬʱӵCH375

#define		mMAX_BUFFER_LENGTH		0x1000		// ݻ󳤶4096

#define		mMAX_COMMAND_LENGTH		( mWIN32_COMMAND_HEAD + mMAX_BUFFER_LENGTH )	// ݳȼṹͷĳ


// CH375˵ַ
#define		mCH375_ENDP_INTER_UP	0x81		// CH375жϴ˵ĵַ
#define		mCH375_ENDP_AUX_DOWN	0x01		// CH375ĸ´˵ĵַ
#define		mCH375_ENDP_DATA_UP		0x82		// CH375ݿϴ˵ĵַ
#define		mCH375_ENDP_DATA_DOWN	0x02		// CH375ݿ´˵ĵַ


// 豸ӿṩĹܵ
#define		mPipeDeviceCtrl			0x00000004	// CH375ۺϿƹܵ
#define		mPipeInterUp			0x00000005	// CH375жϴܵ
#define		mPipeDataUp				0x00000006	// CH375ݿϴܵ
#define		mPipeDataDown			0x00000007	// CH375ݿ´ܵ
#define		mPipeAuxDown			0x00000008	// CH375ĸ´ܵ

// ӦòӿڵĹܴ
#define		mFuncNoOperation		0x00000000	// ޲
#define		mFuncGetVersion			0x00000001	// ȡ汾
#define		mFuncGetConfig			0x00000002	// ȡUSB豸
#define		mFuncSetExclusive		0x0000000b	// öռʹ
#define		mFuncResetDevice		0x0000000c	// λUSB豸
#define		mFuncResetPipe			0x0000000d	// λUSBܵ
#define		mFuncAbortPipe			0x0000000e	// ȡUSBܵ
#define		mFuncSetTimeout			0x0000000f	// USBͨѶʱ
#define		mFuncBufferMode			0x00000010	// 趨ϴģʽѯеݳ
#define		mFuncBufferModeDn		0x00000011	// 趨´ģʽѯеݳ


// USB豸׼
#define		mUSB_CLR_FEATURE		0x01
#define		mUSB_SET_FEATURE		0x03
#define		mUSB_GET_STATUS			0x00
#define		mUSB_SET_ADDRESS		0x05
#define		mUSB_GET_DESCR			0x06
#define		mUSB_SET_DESCR			0x07
#define		mUSB_GET_CONFIG			0x08
#define		mUSB_SET_CONFIG			0x09
#define		mUSB_GET_INTERF			0x0a
#define		mUSB_SET_INTERF			0x0b
#define		mUSB_SYNC_FRAME			0x0c

// CH375ƴĳר
#define		mCH375_VENDOR_READ		0xc0		// ͨƴʵֵCH375רö
#define		mCH375_VENDOR_WRITE		0x40		// ͨƴʵֵCH375רд

// CH375ƴĳר
#define		mCH375_SET_CONTROL		0x51		// ź
#define		mCH375_GET_STATUS		0x52		// ״̬ź

// Ĵλ
#define		mBitInputRxd			0x02		// ֻ,RXD#״̬,1:ߵƽ,0:͵ƽ
#define		mBitInputReq			0x04		// ֻ,REQ#״̬,1:ߵƽ,0:͵ƽ


static const GUID CH375Guid = { 0x5e7f6bdf, 0x1ce5, 0x4d78, { 0xbb, 0xcf, 0xd2, 0xc, 0x44, 0x32, 0x9f, 0x7d } };	// GUID

#endif		// _CH375_WDM_H
